/***************************************************************************
 *	mestree.c: åĥ꡼¤
 *		
 *			Date. 1998/09/27 -- 
 *
 *				Programed by Nobuyuki Maruichi
 *	Note.
 *			JIS X0208-1983/1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************************
 *	øɸ饤֥Υ󥯥롼ɥե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <errno.h>

/*************************************
 *	X Toolkit Υ󥯥롼ɥե
 *************************************/
#include <X11/Intrinsic.h>		/* Intrinsics Definitions */
#include <X11/StringDefs.h>		/* Standard Name-String definitions */

/***********************************************
 *	Xt Intrinsics 饹Υ󥯥롼ɥե
 ***********************************************/
#include <X11/Composite.h>
#include <X11/Core.h>
#include <X11/Shell.h>

/*****************************************
 *	Athena Widget Υ󥯥롼ɥե
 *****************************************/
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Grip.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Repeater.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Panner.h>
#include <X11/Xaw/Porthole.h>
#include <X11/Xaw/Tree.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/Scrollbar.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/Sme.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/StripChart.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/AsciiSrc.h>
#include <X11/Xaw/AsciiSink.h>

/**************************************
 *	acconv ȼΥ󥯥롼ɥե
 **************************************/
#include "xnmess.h"
#include "file_sel.h"

/**************************************
 *	ǡ
 *		SamenameCheckInfomation
 **************************************/
typedef struct samenameCheckInfomation {
	MessTree *myMess;
	String newVariableName;
} SamenameCheckInfomation;

/**************************************************************************
 *	Хѿ
 *		load_fp:			եɤ߹ѥեݥ
 *		save_fp:			ե񤭹ѥեݥ
 *		CurrentMess:		ߤ
 *		CurrentAwMess:		̤
 *		renamePopdownInfo:	͡ॷݥåץ󤹤뤿ι¤
 *		currentWidgetName:	ߤΥå̾
 *		mguiList:			åȼѤΥꥹ
 *		mguiTree:			ĥ꡼ɽΥå
 *		rWidgetName:		å̾Υ͡ѤTextå
 *		rClassName:			͡Υ饹̾ɽѤTextå
 *		rVariableName:		ѿ̾Υ͡ѤTextå
 ***************************************************************************/
FILE *load_fp;
FILE *save_fp;
MessTree *CurrentMess = NULL;
#ifdef	ORIGINAL_IMPREMENT
AWidgetInfo *CurrentAwMess = NULL;
#endif	/* ORIGINAL_IMPREMENT */
XtPopdownIDRec renamePopdownInfo;
String currentWidgetName;
extern Widget mguiList;
extern Widget mguiTree;
Widget rWidgetName, rClassName, rVariableName;

/***************************************************
 *	ХѿʥեΤͭ
 ***************************************************/

/**************************************
 *	ץȥ
 **************************************/

/***************************************************************************
 *	MessAllocʴѤΥݤޤ
 *	
 *		MessTree *MessAlloc(void);
 *	֤
 *		NULL:		顼ʥ­
 *		NULLʳ:	Ƥ줿
 *	
 *		γȽԤ
 *		
 *		
 *		ݤꨭ
 *		
 *		
 *		
 *		 number ġ EOF
 *		
 *		 parent_ptr  NULL
 *		
 *		 child_ptr NULL
 *		
 *		prev_ptr NULL
 *		
 *		next_ptr NULL
 *		
 *		
 ***************************************************************************/
MessTree *MessAlloc(void)
{
	MessTree *alloc_ptr;
	
	alloc_ptr = (MessTree*)XtMalloc(sizeof(MessTree));
	if(alloc_ptr != NULL) {
		alloc_ptr->number     = EOF;
		alloc_ptr->message    = NULL;
		alloc_ptr->treeWidget = NULL;
		alloc_ptr->parent_ptr = NULL;
		alloc_ptr->child_ptr  = NULL;
		alloc_ptr->prev_ptr   = NULL;
		alloc_ptr->next_ptr   = NULL;
	}
	return(alloc_ptr);
}

#ifdef	TEST_IMPREMENT
/***************************************************************************
 *	messageUnlinkĥ꡼ʤʥ󥯡ˤ
 *	
 *		MessTree *messageUnlink(MessTree *message);
 *	
 *		MessTree *message;		󥯤
 *	֤
 *		NULLʳ	󥯤
 *	
 *		  Ƥ¸ߤ뤬¸ߤʤ
 *		
 *		ƤҤؤΥ
 *		
 *		ʨʨ
 *		
 *		ҤƤؤΥ
 *		
 *		ƤҤؤΥ󥯤ڤΥ
 *		 NULL
 *		ʨ
 *		ʨ
 *		
 *		ҤƤؤΥ
 *		
 *		  ʳʤࡢɤʤäƤ뤫˺줿
 *		
 *		ʡ
 *		
 *		
 *		ƤҤء
 *		 NULL
 *		ʨʨ
 *		
 *		ҤƤء
 *		
 *		
 *		ʡ
 *		
 *		
 *		
 *	Х
 *		ʤȻҶʤξƱ¸ߤϡ󥯤
 *		ޤ
 *		Ūˤϡ¹˳Ƥ
 *		
 ***************************************************************************/
MessTree *messageUnlink(MessTree *message)
{
	if(message != NULL) {
		if(message->parent_ptr != NULL && 
					message->prev_ptr == NULL && message->next_ptr == NULL) {
			/*****************************************
			 *	Ƥ¸ߤ뤬¸ߤʤ
			 *****************************************/
			message->parent_ptr->child_ptr = message->child_ptr;
		} else {
			if(message->child_ptr == NULL) {
				if(message->prev_ptr != NULL) {
					message->prev_ptr->next_ptr = NULL;
				}
				if(message->next_ptr != NULL) {
					message->next_ptr->prev_ptr = NULL;
				}
			} else {
				fprintf(stderr, "%s:%d:messageUnlink() error. "
					"Can't Unlink!! / "
					"This message has child & brother(s).\n", 
					__FILE__, __LINE__);
				abort();
			}
		}
		message->parent_ptr = NULL;
	}
	return(message);
}

/***************************************************************************
 *	messageUnlinkAndFreeĥ꡼ʤʥ󥯡ˡ
 *	
 *		void messageUnlinkAndFree(MessTree *message);
 *	
 *		MessTree *message;	󥯡
 *	
 *		
 *	Х
 *		ʤȻҶʤξƱ¸ߤϡ󥯤
 *		ޤ
 *		Ūˤϡ¹˳Ƥ
 *		
 ***************************************************************************/
void messageUnlinkAndFree(MessTree *message)
{
	MessFree(messageUnlink(message));
}
#endif	TEST_IMPREMENT

/***************************************************************************
 *	MessTopTraceĥ꡼¤ȥ졼
 *	
 *		void MessTopTrace(MessTree *message, 
 *									void (*MessProc)(MessTree *message));
 *	
 *		MessTree *message;						ʴ
 *		void (*MessProc)(MessTree *message);
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 *	ȥ졼˻Ѥʤݥ
 *		
 *		ʤοޤǡߤ֤Ƥݥ󥿤ϻѤƤޤ
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		ߡߡߨߡߡߨ
 *		ߡߡߡߡ
 *		ߡߡߡߡ
 *		ߡߡ
 *		ߡʡʣ˨ߡʡʣ˨
 *		ߡߨߡߨ
 *		ߡߡ
 *		ߡߡ
 *		ߡ
 *		ߡʡʣ˨ʡʣ˨
 *		ߡߨߡߡߨ
 *		ߡߡ
 *		ߡߡ
 *		ߡ
 *		ߡʡʣ˨
 *		ߡߨ
 *		
 *		ϡ¾Υȥ졼äɽƤʤΤƱǤ
 *		
 ***************************************************************************/
void MessTopTrace(MessTree *message, void (*MessProc)(MessTree *message))
{
	if(message != NULL) {
		if(MessProc != NULL) {
			MessProc(message);
		}
		if(message->child_ptr != NULL) {
			MessTopTrace(message->child_ptr, MessProc);
		}
		if(message->next_ptr != NULL) {
			MessTopTrace(message->next_ptr, MessProc);
		}
	}
}

/***************************************************************************
 *	MessBottomTrace: ĥ꡼¤ȥ졼Ԥ
 *	
 *		void MessBottomTrace(MessTree *message, 
 *									void (*MessProc)(MessTree *message));
 *	
 *		MessTree *message;						ʴ
 *		void (*MessProc)(MessTree *message);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 *		
 *	Х
 *		ʤȻҶʤξƱ¸ߤϡ󥯤
 *		ޤ
 *		Ūˤϡ¹˳Ƥ
 *		
 ***************************************************************************/
void MessBottomTrace(MessTree *message, void (*MessProc)(MessTree *message))
{
	if(message != NULL) {
		if(message->child_ptr != NULL) {
			MessBottomTrace(message->child_ptr, MessProc);
		}
		if(message->next_ptr != NULL) {
			MessBottomTrace(message->next_ptr, MessProc);
		}
		if(MessProc != NULL) {
			MessProc(message);
		}
	}
}

/***************************************************************************
 *	MessSum: ĥ꡼¤ȥ졼餫ιͤ
 *	
 *		int MessSum(MessTree *message, int (*MessProc)(MessTree *message));
 *	
 *		MessTree *message;		ʴ
 *		int (*MessProc)(MessTree *message);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		ߤϡѤƤʤ
 *		
 ***************************************************************************/
int MessSum(MessTree *message, int (*MessProc)(MessTree *message))
{
	int sum = 0;

	if(MessProc != NULL) {
		sum += MessProc(message);
	}
	if(message->child_ptr != NULL) {
		sum += MessSum(message->child_ptr, MessProc);
	}
	if(message->next_ptr != NULL) {
		sum += MessSum(message->next_ptr, MessProc);
	}
	return(sum);
}

/***************************************************************************
 *	MessSearch: ĥ꡼¤ȥ졼
 *	
 *		XtPointer MessSearch(MessTree *message, 
 *								XtPointer (*MessProc)(MessTree *message));
 *	
 *		MessTree *message;							ʴ
 *		XtPointer (*MessProc)(MessTree *message);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		긡
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
XtPointer MessSearch(MessTree *message, XtPointer client_data, 
			XtPointer (*MessProc)(MessTree *message, XtPointer client_data))
 ***************************************************************************/
 
/***************************************************************************
 *	MessSearch: 
 *	
 *		XtPointer MessSearch(MessTree *message, XtPointer client_data, XtPointer (*MessProc)(MessTree *message, XtPointer client_data));
 *	
 *		MessTree *message;
 *		XtPointer client_data;
 *		XtPointer (*MessProc)(MessTree *message, XtPointer client_data);
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
XtPointer MessSearch(MessTree *message, XtPointer client_data, XtPointer (*MessProc)(MessTree *message, XtPointer client_data))
{
	XtPointer target = NULL;

	if(MessProc != NULL) {
		target = MessProc(message, client_data);
	}
	if(message->child_ptr != NULL && target == NULL) {
		target = MessSearch(message->child_ptr, client_data, MessProc);
	}
	if(message->next_ptr != NULL && target == NULL) {
		target = MessSearch(message->next_ptr, client_data, MessProc);
	}
	return(target);
}

/***************************************************************************
 *	MessTopTrace2: ĥ꡼¤ȥ졼
 *	
 *		void MessTopTrace2(MessTree *message, XtPointer client_data, 
 *				void (*MessProc)(MessTree *message, XtPointer client_data));
 *	
 *		MessTree *message;			ʴ
 *		XtPointer client_data;
 *		void (*MessProc)(MessTree *message, XtPointer client_data);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 ***************************************************************************/
void MessTopTrace2(MessTree *message, XtPointer client_data, 
				void (*MessProc)(MessTree *message, XtPointer client_data))
{
	if(MessProc != NULL) {
		MessProc(message, client_data);
	}
	if(message->child_ptr != NULL) {
		MessTopTrace2(message->child_ptr, client_data, MessProc);
	}
	if(message->next_ptr != NULL) {
		MessTopTrace2(message->next_ptr, client_data, MessProc);
	}
}

/***************************************************************************
 *	MessTopDownTrace: ĥ꡼¤ȥ졼
 *	
 *		void MessTopDownTrace(MessTree *message, Boolean (*MessProc)(MessTree *message));
 *	
 *		MessTree *message;						ʴ
 *		Boolean (*MessProc)(MessTree *message);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 ***************************************************************************/
void MessTopDownTrace(MessTree *message, Boolean (*MessProc)(MessTree *message))
{
	Boolean realizedFlag = True;

	if(message != NULL) {
		if(MessProc != NULL) {
			realizedFlag = MessProc(message);
		}
		if(realizedFlag == FALSE && message->child_ptr != NULL) {
			MessTopDownTrace(message->child_ptr, MessProc);
		}
		if(message->next_ptr != NULL) {
			MessTopDownTrace(message->next_ptr, MessProc);
		}
	}
}

#ifdef	TEST_IMPREMENT
/***************************************************************************
 *	TestNearlyMessLink: 
 *	
 *		static int TestNearlyMessLink(MessTree *message);
 *	
 *		MessTree *message;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
static int TestNearlyMessLink(MessTree *message)
{
	int linkIsMissing = FALSE;

	if(message == NULL) {
		return(EOF);
	}
	if(message->prev_ptr != NULL) {
		/* ȿƤȤΥ󥯤ʰ׳ǧ */
		linkIsMissing |= message->prev_ptr->next_ptr != message;
		linkIsMissing |= message->prev_ptr->parent_ptr != message->parent_ptr;
	} else {
		/* ƤȤΥ󥯤ǧ */
		linkIsMissing |= (message->parent_ptr != NULL && 
								message->parent_ptr->chile_ptr != message);
	}
}

/***************************************************************************
 *	MessTraceSameParents: ĥ꡼¤ȥ졼
 *	
 *		void MessTopTrace2(MessTree *message, XtPointer client_data, 
 *				void (*MessProc)(MessTree *message, XtPointer client_data));
 *	
 *		MessTree *message;			ʴ
 *		XtPointer client_data;
 *		void (*MessProc)(MessTree *message, XtPointer client_data);
 *	֤
 *		
 *	
 *		ʲΤ褦ˡ¦ȥ졼ʤꤵ줿ؿˤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 ***************************************************************************/
int MessTraceSameParents(MessTree *message, XtPointer client_data, 
				void (*MessProc)(MessTree *message, XtPointer client_data))
{
	int finished = FALSE;

	if(MessProc != NULL) {
		finished = MessProc(message, client_data);
	}
	if(!finished && message->child_ptr != NULL) {
		finished = MessTraceSameParents(message->child_ptr, client_data, MessProc);
	}
	if(!finished && message->next_ptr != NULL) {
		finished = MessTraceSameParents(message->next_ptr, client_data, MessProc);
	}
	return(finished);
}
#endif	/*TEST_IMPREMENT*/

/***************************************************************************
 *	isMess: ƥʤꥢ饤Ƥ뤫ɤȽꤹؿ
 *	
 *		int isMess(MessTree *message);
 *	
 *		MessTree *message;		ʴ
 *	֤
 *		FALSE:		¸Ƥʤ
 *		TRUE:		¸Ƥ
 *	
 *		
 ***************************************************************************/
int isMess(MessTree *message)
{
	return((message != NULL)?(message->message != NULL):(FALSE));
}

/***************************************************************************
 *	whereIsMessWidget: ʤƥʤΥåȤ֤ؿ
 *	
 *		XtPointer whereIsMessWidget(MessTree *message);
 *	
 *		MessTree *message;		ʴ
 *	֤
 *		NUUL:		ƥʤǤʤä̤
 *		NULLʳ:	ƥʤΥåȤؤݥ
 *	
 *		
 ***************************************************************************/
XtPointer whereIsMessWidget(MessTree *message)

{
	return((XtPointer)(message != NULL)?(message->message):(NULL));
}

/***************************************************************************
 *	whereIsTreeWidget: ʤĥ꡼ʤΥåȤ֤ؿ
 *	
 *		XtPointer whereIsTreeWidget(MessTree *message);
 *	
 *		MessTree *message;		ʴ
 *	֤
 *		NUUL:		ĥ꡼¤ɽѥȤǤʤä
 *		NULLʳ:	ĥ꡼¤ɽѥȤؤݥ
 *	
 *		
 ***************************************************************************/
XtPointer whereIsTreeWidget(MessTree *message)
{
	return((XtPointer)(message != NULL)?(message->treeWidget):(NULL));
}

/***************************************************************************
 *	youngestBrother: ƱΡɤθǺǸ˺줿ʤõ
 *	
 *		MessTree *youngestBrother(MessTree *message);
 *	
 *		MessTree *message;		ʴ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
MessTree *youngestBrother(MessTree *message)
{
	if(message != NULL) {
		while(message->next_ptr != NULL)
			message = message->next_ptr;
	}
	return(message);
}

/***************************************************************************
 *	connectToTailƱΡɤθǺǸʤؤ󥯥ݥ󥿤õ
 *	
 *		MessTree **connectToTail(MessTree **message);
 *	
 *		MessTree *message;		ʴ
 *	֤
 *		
 *	
 *		ƱΡɤθǺǸʤؤ󥯥ݥ󥿤Υɥ쥹֤
 *		̤ѡ
 *		
 ***************************************************************************/
MessTree **connectToTail(MessTree **message)
{
	if(*message != NULL) {
		while((*message)->next_ptr != NULL)
			message = &(*message)->next_ptr;
	}
	return(message);
}

/***************************************************************************
 *	messageChildLinkĥ꡼ʤϢʥ󥯡ˤ
 *	
 *		MessTree *messageChildLink(MessTree *node, MessTree *newMess);
 *	
 *		MessTree *node;		ʤɲä֡ʥΡɡ
 *		MessTree *newMess;	ʻҶȤơ³
 *	֤
 *		NULL		顼
 *		NULLʳ	ɲä줿ʤΥΡ
 *	
 *		ߤιˤꣲϢʥ󥯡ˡޤ줾
 *		ˡ򼨤ޤ
 *		
 *		  ʤɲäΡɤ˻ҥåȤ¸ߤʤ
 *		
 *		
 *		
 *		ʹĥ꡼ΥΡɨʨ
 *		
 *		 number  number 
 *		
 *		 message message
 *		
 *		 treeWidget  treeWidget 
 *		
 *		 parent_ptr  parent_ptr 
 *		
 *		 child_ptr child_ptr   NULL 
 *		
 *		prev_ptr롡prev_ptr NULL 
 *		  
 *		next_ptrnext_ptr NULL 
 *		
 *		
 *		
 *		
 *		  ʤɲäΡɤ˻ҥåȤ¸ߤ
 *		
 *		ʹĥ꡼κܨʺǯĹΡ˻ʨ
 *		
 *		 number  number 
 *		
 *		 message
 *		
 *		 treeWidget  parent_ptr 
 *		
 *		 parent_ptr  child_ptr  
 *		
 *		 child_ptrprev_ptr NULL 
 *		
 *		prev_ptrnext_ptr
 *		
 *		next_ptr
 *		
 *		 parent_ptr Ǥ
 *		ʺǯ
 *		 child_ptr  λʨ 
 *		
 *		prev_ptr NULL 
 *		
 *		next_ptr
 *		
 *		
 *		
 *		ɲäʨ
 *		
 *		 number ʸ
 *		
 *		Ψmessage 
 *		ꨢ
 *		󨢡 treeWidget 
 *		
 *		 parent_ptr 
 *		
 *		먢 child_ptr   NULL 
 *		󥯨
 *		prev_ptr
 *		
 *		먭next_ptr NULL 
 *		󥯨
 *		
 *		
 *		
 ***************************************************************************/
MessTree *messageChildLink(MessTree *node, MessTree *newMess)
{
	if(node != NULL && newMess != NULL) {
		if(node->child_ptr == NULL) {
			/*********************************************************
			 *	ʤɲäΡɤ˻ҥåȤ¸ߤʤ
			 *********************************************************/
			node->child_ptr = newMess;
			newMess->parent_ptr = node;
		} else {
			/*******************************************************
			 *	ʤɲäΡɤ˻ҥåȤ¸ߤ
			 *******************************************************/
			newMess->parent_ptr = node;
			newMess->prev_ptr = youngestBrother(node->child_ptr);
			newMess->prev_ptr->next_ptr = newMess;
		}
	}
	return(node);
}

/***************************************************************************
 *	rootMessĥ꡼κܤ֤
 *	
 *		MessTree *rootMess(MessTree *node);
 *	
 *		MessTree *node;		
 *	֤
 *		NULL		顼
 *	
 *		ʹĥ꡼ǿƤؤݥ󥿤Ȥäƥĥ꡼¤κܤõޤ
 *		
 *		ߢߢ
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		ߡ
 *		
 *		
 *		ʡʣ˨
 *		
 *	
 ***************************************************************************/

/***************************************************************************
 *	MessRootDownTrace: 
 *	
 *		void MessRootDownTrace(MessTree *message, XtPointer client_data, 
 *				void (*MessProc)(MessTree *message, XtPointer client_data));
 *	
 *		MessTree *message;
 *		XtPointer client_data;
 *		void (*MessProc)(MessTree *message, XtPointer client_data);
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void MessRootDownTrace(MessTree *message, XtPointer client_data, 
				void (*MessProc)(MessTree *message, XtPointer client_data))
{
	if(message->parent_ptr != NULL) {
		MessRootDownTrace(message->parent_ptr, client_data, MessProc);
	}
	MessProc(message, client_data);
}

/***************************************************************************
 *	MessNodeLevelTrace: 
 *	
 *		int MessNodeLevelTrace(MessTree *message, 
 *				int relative, XtPointer client_data, 
 *				void (*MessProc)(MessTree *message, 
 *						int absolute, int relative, XtPointer client_data));
 *	
 *		MessTree *message;
 *		int relative;
 *		XtPointer client_data;
 *		void (*MessProc)(MessTree *message, 
 *				int absolute, int relative, XtPointer client_data);
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int MessNodeLevelTrace(MessTree *message, int relative, XtPointer client_data, 
				void (*MessProc)(MessTree *message, 
						int absolute, int relative, XtPointer client_data))
{
	int absolute = 0;

	if(message->parent_ptr != NULL) {
		absolute = MessNodeLevelTrace(message->parent_ptr, relative - 1, 
													client_data, MessProc);
	}
	MessProc(message, absolute, relative, client_data);
	++absolute;

	return(absolute);
}

/***************************************************************************
 *	rootMessĥ꡼κܤ֤
 *	
 *		MessTree *rootMess(MessTree *node);
 *	
 *		MessTree *node;		
 *	֤
 *		NULL		顼
 *	
 *		ʹĥ꡼ǿƤؤݥ󥿤Ȥäƥĥ꡼¤κܤõޤ
 *		
 *		ߢߢ
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		ߡ
 *		
 *		
 *		ʡʣ˨
 *		
 *	
 ***************************************************************************/
MessTree *rootMess(MessTree *message)
{
	while(message->parent_ptr != NULL)
		message = message->parent_ptr;
	return(message);
}

/***************************************************************************
 *	messageAppendĥ꡼ʤɲä
 *	
 *		MessTree *messageAppend(MessTree *node, 
 *							const char *widgetName, AWidgetInfo *awInfo);
 *	
 *		MessTree *node;		ʤɲä֡ʥΡɡ
 *		char *widgetName;		ɲäʤΥå̾
 *		AWidgetInfo *awInfo;	ɲäʤξ
 *	֤
 *		NULL		­or顼
 *		NULLʳ	ɲäʤΥΡ
 *	
 *		ʲνԤޤ
 *		
 *		  ʤʽ줿
 *		  å̾˥Ƥ̾򥳥ԡ
 *		  ʼ
 *		  ĥ꡼ѤΥåȤκʥ٥դ
 *		  ĥ꡼ѤΥåȤΥ饸롼פؤɲ
 *		  ĥ꡼ѤΥåȤʰּؿΥХåϿ
 *		  ĥ꡼ѤΥåȤμ¸
 *		
 *		ʬϰʲ̤
 *		
 *		Ƥꨭ
 *		
 *		֤͡
 *		
 *		
 *		 number 
 *		
 *		message 
 *		
 *		 treeWidget ĥ꡼ɽѤΥåȨ
 *		
 *		 parent_ptr  NULL 
 *		륦åȨ
 *		 child_ptr NULL 
 *		
 *		prev_ptr NULL
 *		
 *		next_ptr NULL
 *		
 *		
 ***************************************************************************/
MessTree *messageAppend(MessTree *node, 
								const char *widgetName)
{
	MessTree *newMess;
	extern Widget mguiTree;

	newMess = MessAlloc();	/* ʤο */
	if(newMess != NULL) {
#ifdef	NEXT_IMPREMENT
		newMess->widgetName = XtNewString(widgetName);	/* å̾ */
#endif	/* NEXT_IMPREMENT */
		newMess->treeWidget = 
#ifndef	NEXT_IMPREMENT
				NULL;
#else
				XtVaCreateManagedWidget(
						widgetName, 
						toggleWidgetClass, 
						mguiTree, 
						XtNtreeParent, 
								((node != NULL)?(node->treeWidget):(NULL)), 
						/* XtNlabel, newMess->widgetName, */
						XtNlabel, defaultLabel(newMess),
						XtNradioData, newMess,
						NULL);
#endif	/* NEXT_IMPREMENT */
		if(node != NULL) {
			/* 饸롼פ礹 */
			XawToggleChangeRadioGroup(newMess->treeWidget, node->treeWidget);
		}
#ifdef	NEXT_IMPREMENT
		XtAddCallback(newMess->treeWidget, 
						XtNcallback, messagePointer, (XtPointer)newMess);
		XtRealizeWidget(newMess->treeWidget);	/* ĥ꡼¤ʤμ¸ */
#endif	/* NEXT_IMPREMENT */
	}
	return(newMess);
}

/***************************************************************************
 *	messageAddʤɲä
 *	
 *		void messageAdd(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	ʾ
 *		XtPointer call_data;	̤
 *	
 *		
 *		
 *		ʬϰʲ̤
 *		
 *		Ƥꨭ
 *		
 *		
 *		
 *		 number 
 *		
 *		 message NULL: ƥȼ¸ѤΥå
 *		
 *		 treeWidget  NULL:̤ѤΤ
 *		
 *		 parent_ptr  NULL or Ƥإ
 *		
 *		 child_ptr NULL 
 *		
 *		prev_ptr NULL or ˤʡ¸ߤ
 *		
 *		next_ptr NULL
 *		
 *	Ȼ
 *		messageChildLink();ġġ󥯤ĥˤĤƤξ
 *		currentWidgetNameġġߤΥå̾ʥ롼Хѿ
 *		
 ***************************************************************************/
void messageAdd(MessTree *newMess, MessTree **root, MessTree *parent)
{
	if(parent != NULL) {
		/*************************
		 *	ȯ¸ߤ
		 *************************/
		(void)messageChildLink(parent, newMess);
	} else {
		if(*root == NULL) {
			/*************************
			 *	ǽȯΤȤΤ
			 *************************/
			*root = newMess;
		} else {
			/*************************
			 *	̤ȯΤȤΤ
			 *************************/
			newMess->prev_ptr = youngestBrother(*root);
			newMess->prev_ptr->next_ptr = newMess;
		}
	}
}

/***************************************************************************
 *	messageDeleteOne: ꤵ줿ʤ
 *	
 *		void messageDeleteOne(MessTree *message);
 *	
 *		MessTree *message;	ʴ
 *	֤
 *		
 *	
 *		ߤιˤꣲϢʥ󥯡ˡޤ줾
 *		ˡ򼨤ޤ
 *		
 *		  ʤɲäΡɤ˻ҥåȤ¸ߤʤ
 *		
 *		
 *		
 *		ʹĥ꡼ΥΡɨʨ
 *		̵ˤʨ
 *		 widgetName ʸ󨭡󥯡
 *		
 *		variableNameʸ󨭡 parent_ptr 
 *		
 *		  className ʸ󨭡 child_ptr   NULL 
 *		
 *		 messageWidgetprev_ptr NULL 
 *		
 *		 treeWidget next_ptr
 *		
 *		mapping 
 *		郎ʤ NULL
 *		 athenaInfo ġ
 *		ʡ
 *		 parent_ptr 
 *		
 *		 child_ptr
 *		 parent_ptr 
 *		prev_ptrѡ
 *		 child_ptr  
 *		next_ptr
 *		prev_ptr
 *		
 *		next_ptr
 *		롡郎
 *		ꡡ
 *		󡡡
 *		
 *		
 *			ڢۡѹ
 *			ڢ̵ۡˤʤ󥯡˻Ѥޤ
 *		
 *		
 *		  ʤɲäΡɤ˻ҥåȤ¸ߤ
 *		
 *		ʹĥ꡼κܨʨ
 *		
 *		 widgetName ʸ󨭡
 *		
 *		variableNameʸ󨭡 parent_ptr 
 *		
 *		  className ʸ󨭡 child_ptr  
 *		
 *		 messageWidgetprev_ptrNULL
 *		
 *		 treeWidget next_ptr
 *		
 *		mapping 
 *		ʨ
 *		 athenaInfo 
 *		
 *		 parent_ptr 
 *		 parent_ptr 
 *		 child_ptr
 *		 child_ptr  
 *		prev_ptr
 *		prev_ptr
 *		next_ptr
 *		next_ptr
 *		
 *		
 *		ʡ
 *		
 *		
 *		
 *		 parent_ptr 
 *		
 *		 child_ptr  
 *		
 *		prev_ptr
 *		
 *		next_ptr
 *		Ѥ
 *		
 *		
 *		
 *			ڢۡѹΥ
 *			ڢۡѹΥ󥯡ʹ줿󥯡
 *			ڢ̵ۡˤʤ󥯡˻Ѥޤ
 *	Х
 *		1997/12/17 ʳޤǤǤϡ󥯤κˡ꤬롣
 *		1997/12/18 νˤƤνϴǤϤʤ
 *		ϡʤ¸ߤΤθƤʤˤ롣
 *		
 ***************************************************************************/
void messageDeleteOne(MessTree *message)
{
	if(message != NULL) {
		if(message->prev_ptr == NULL) {
			/***********************
			 *	ʤ¸ߤʤ
			 ***********************/
			if(message->parent_ptr != NULL) {
				/* ϡƤΥ󥯤ǤΤ */
				if(message->next_ptr != NULL) {
					message->parent_ptr->child_ptr = message->next_ptr;	/* ɲ */
					message->next_ptr->prev_ptr = NULL;	/* ɲ */
				} else {
					message->parent_ptr->child_ptr = NULL;
				}
			}
		} else {
			/*********************
			 *	ʤ¸ߤ
			 *********************/
			message->prev_ptr->next_ptr = message->next_ptr;
			if(message->next_ptr != NULL) {
				message->next_ptr->prev_ptr = message->prev_ptr;
			}
		}
		XtDestroyWidget(message->treeWidget);
		XtFree((char*)message);
	}
}

/***************************************************************************
 *	messageDeleteʤ
 *	
 *		void messageDelete(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				mguiDel/cmdMenuInfo.myWidget[2] å
 *		XtPointer client_data;	ʾ
 *		XtPointer call_data;	̤
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ġ				mguiDel			ľܤΥХå
 *	
 *		˥塼	cmdMenuInfo[2].myWidget	messageDeleteInMenu 
 *	
 *		
 *		ʲΤ褦ˡ¦ȥ졼ʤʲνʤ
 *		롣
 *		
 *		
 *		ʡʣ˨ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨ʡʣ˨
 *		
 *		
 *		
 *		
 *		ʡʣ˨
 *		
 *		
 *		
 *	Ȼ
 *		messageDeleteOne() -- ꤵ줿ʤؿ
 *		
 ***************************************************************************/
void messageDelete(Widget w, XtPointer client_data, XtPointer call_data)
{
	MessTree **message = (MessTree**)client_data;
	MessTree *newMess;
	Widget parentTree;
	extern Widget mguiTree;

	if(message != NULL) {
		if(*message != NULL) {
			MessBottomTrace((*message)->child_ptr, messageDeleteOne);
			messageDeleteOne(*message);
			*message == NULL;
		}
	}
}

/***************************************************************************
 *	PopdownAncestorShell: åȤκǤᤤĤΥݥåץ
 *	
 *		void PopdownAncestorShell(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				ݥåץ׵ᤷå
 *		XtPointer client_data;	̤
 *		XtPointer call_data;	̤
 *	֤
 *		
 *	
 *		ѤΥХåؿåȤκǤᤤĤΥݥå
 *		󤷤ޤ
 *		
 *	
 *		ʤξ		å̾			
 *	
 *			mguiPopdown			ľܤΥХå
 *			ġ							mguiSourceShell ݥå
 *												
 *	
 *		꥽	mguiResFilePopdown		ľܤΥХå
 *			ġ							mguiResourceFileShell 
 *												ݥåץ
 *	
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
void PopdownAncestorShell(Widget w, XtPointer client_data, XtPointer call_data)
{
	Widget popdownWidget = w;

	while(popdownWidget != NULL && XtIsShell(popdownWidget) == False) {
		popdownWidget = XtParent(popdownWidget);
	}

	XtPopdown(popdownWidget);
}

/***************************************************************************
 *	hasParent: ƥåȤ¸ߤĴ٤
 *	
 *		Boolean hasParent(MessTree *message);
 *	
 *		MessTree *message;			ʴ
 *	֤
 *		:		ƥåȤ¸
 *		:		ƥåȤ¸ߤʤ
 *	
 *		
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasParent(MessTree *message)
{
	Boolean result = FALSE;

#ifdef	DEBUG
	printf("hasParent<");
#endif	/*DEBUG*/
	if(message != NULL) {
		result = (message->parent_ptr != NULL);
#ifdef	OLD_IMPREMENT
		result = ((message->parent_ptr != NULL)?
						(message->parent_ptr->message != NULL):(False));
#endif	/*OLD_IMPREMENT*/
	}
#ifdef	DEBUG
	printf("=%d>", result);	fflush(stdout);
#endif	/*DEBUG*/
	return(result);
}

/***************************************************************************
 *	hasChild: ҥåȤ¸ߤĴ٤
 *	
 *		Boolean hasChild(MessTree *message);
 *	
 *		MessTree *message;			ʴ
 *	֤
 *		:		ҥåȤ¸
 *		:		ҥåȤ¸ߤʤ
 *	
 *		ƹǽȽؿ
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasChild(MessTree *message)
{
	Boolean result = FALSE;

#ifdef	DEBUG
	printf("hasChild<");
#endif	/*DEBUG*/
	if(message != NULL) {
		result = (message->child_ptr != NULL && 
								message->child_ptr->message != NULL);
	}
	return(result);
}

/***************************************************************************
 *	hasFamily: ơҥåȤ¸ߤĴ٤
 *	
 *		Boolean hasFamily(MessTree *message);
 *	
 *		MessTree *message;			ʴ
 *	֤
 *		:		ơҥåȤ¸
 *		:		ơҥåȤ¸ߤʤ
 *	
 *		ƹǽȽؿ
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasFamily(MessTree *message)
{
	Boolean result = FALSE;

	if(message != NULL) {
		result = (message->parent_ptr != NULL && message->child_ptr != NULL);
	}
	return(result);
}

/***************************************************************************
 *	hasNoFamily: ơҥåȤ¸ߤĴ٤
 *	
 *		Boolean hasNoFamily(MessTree *message);
 *	
 *		AWidgetInfo *myWidget;	
 *		MessTree *message;			ʴ
 *	֤
 *		:		ơҥåȤ¸ߤʤ
 *		:		ơҥåȤ¸
 *	
 *		ĥ꡼¤ǽȽؿ
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean hasNoFamily(MessTree *message)
{
	return(message == NULL);
}

/***************************************************************************
 *	messageExist: 򤵤ƤѡĤ¸ߤĴ٤
 *	
 *		Boolean messageExist(MessTree *message);
 *	
 *		AWidgetInfo *myWidget;	
 *		MessTree *message;			ʴ
 *	֤
 *		:		򤵤Ƥ륦åȤ¸
 *		:		򤵤Ƥ륦åȤ¸ߤʤ
 *	
 *		ĥ꡼¤ǽȽؿ
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean messageExist(MessTree *message)
{
	return(message != NULL);
}

/***************************************************************************
 *	alwaysMakable: ˥åȺǽʤȤ֤ؿ
 *	
 *		Boolean alwaysMakable(MessTree *message);
 *	
 *		AWidgetInfo *myWidget;	
 *		MessTree *message;			ʴ
 *	֤
 *		˿		ʥåȺǽ
 *	
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean alwaysMakable(MessTree *message)
{
	return(True);
}

/***************************************************************************
 *	alwaysDismakable: ˥åȺԲǽʤȤ֤ؿ
 *	
 *		Boolean alwaysDismakable(MessTree *message);
 *	
 *		AWidgetInfo *myWidget;	
 *		MessTree *message;			ʴ
 *	֤
 *		˵		ʥåȺԲǽ
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
Boolean alwaysDismakable(MessTree *message)
{
	return(False);
}

/***************************************************************************
 *	saveFileLineեˣ¸
 *	
 *		void saveFileLine(const char *string);
 *	
 *		const char *string;		ե¸ʸ
 *	
 *		
 ***************************************************************************/
void saveFileLine(const char *string)
{
	fprintf(save_fp, "%s\n", string);
}

/***************************************************************************
 *	treeList: ʣĤʥĥ꡼եسǼ
 *	
 *		void treeList(MessTree *message, XtPointer client_data);
 *	
 *		MessTree *message;		եسǼ
 *		XtPointer client_data;	
 *	֤
 *		
 *	
 *		δؿϡʣʬʥĥ꡼եسǼ뤿
 *		ؿǤ롣
 *		δؿ MessTopTrace() ʲΤ褦ˤȡ
 *		
 *		    MessTopTrace(messageRoot, treeList);   
 *		      messageRoot  ʥĥ꡼κ 
 *		      treeList   δؿ 
 *		
 *		ʥĥ꡼Τ¸Ǥ롣
 *		
 ***************************************************************************/
void treeList(MessTree *message)
{
	int counter;
	int length = 0;
	char stringBuffer[1024];
	MessTree *message_ptr;

	for(counter = 0, message_ptr = message;message_ptr->parent_ptr != NULL;
							message_ptr = message_ptr->parent_ptr, ++counter) {
		length += sprintf(stringBuffer+length, "");
	}
	if(counter == 0) {
		length += sprintf(stringBuffer+length, "%s", *message->message);
		printf("%s", stringBuffer);
	}
}

/***************************************************************************
 *	youngestInLevelꤵ줿ŪʿƻҴطǰּ㤤ʤõ
 *	
 *		MessTree *youngestInLevel(MessTree *nodeMess, int relativeLevel);
 *	
 *		MessTree *nodeMess;	
 *		int relativeLevel;		ƻҴطʲλ¹򼨤
 *	֤
 *		NULL:		ꤵ줿ŪʿƻҴطȯǤʤä
 *		NULLʳ:	ꤵ줿ŪʿƻҴطǰּ㤤ʤ֤
 *	
 *	
 ***************************************************************************/
MessTree *youngestInLevel(MessTree *nodeMess, int relativeLevel)
{
	int exitFlag;
	int level = 0;
	MessTree *youngestMess = NULL;

	if(relativeLevel >= 0) {
		youngestMess = nodeMess;
		do {
			exitFlag = TRUE;
			youngestMess = youngestBrother(youngestMess);
			if(youngestMess->child_ptr != NULL) {
				if(level < relativeLevel) {
					level++;
					youngestMess = youngestMess->child_ptr;
					exitFlag = FALSE;
				}
			}
		} while(exitFlag == FALSE);
	}
	
	return((relativeLevel == level)?(youngestMess):(NULL));
}

/***************************************************************************
 *	stringSearchʸ˰פʸ󤬤뤫ɤȽꤹ
 *	
 *		int stringSearch(const char *commandLine, const char **commands);
 *	
 *		const char *commandLine;	о
 *		const char **commands;		ʸʤNULLݥ󥿤ǽ
 *	֤
 *		EOF: 	פʸ¸ߤʤ
 *		0ʾ: 	פʸֹ
 *	
 *		ʸ˰פʸ󤬤뤫ɤȽꤹ
 ***************************************************************************/
int stringSearch(const char *commandLine, const char **commands)
{
	int status = EOF;
	int counter;

	for(counter = 0;*(commands+counter) != NULL && status != 0;++counter) {
		status = strcmp(commandLine, *(commands+counter));
	}
	return((status == 0)?(counter-1):(EOF));
}

/***************************************************************************
 *	noArgذʤ١Ѥδؿ
 *	
 *		char *noArg(MessTree *message);
 *	
 *		MessTree *message;		ʾ̤ѡ
 *	֤
 *		ˡʸؤΥݥ
 *	
 *		ذʤ١źѤδؿ
 *		ذνüѡ٤бʸ뤿Τºݤ
 *		̤ѤƱˤʤ롣
 ***************************************************************************/
char *noArg(MessTree *message)
{
	return("");
}

#ifdef	NEXT_IMPREMENT
/***************************************************************************
 *	argWidgetإåѿ̾١Ѥδؿ
 *	
 *		char *argWidget(MessTree *message);
 *	
 *		MessTree *message;		ʾ
 *	֤
 *		åѿ̾
 *	
 *	
 ***************************************************************************/

/***************************************************************************
 *	numberOfMessage: 
 *	
 *		int numberOfMessage(MessTree *message);
 *	
 *		MessTree *message;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int numberOfMessage(MessTree *message)
{
	int number = EOF;

	if(message != NULL) {
		number = message->number;
	}
	return(number);
}
#endif	/*NEXT_IMPREMENT*/

/***************************************************************************
 *	argWidgetNameإå̾١Ѥδؿ
 *	
 *		char *argWidgetName(MessTree *message);
 *	
 *		MessTree *message;		ʾ
 *	֤
 *		NULL:		顼
 *		NULLʳ:	å̾
 *	
 *	
 ***************************************************************************/

/***************************************************************************
 *	bodyOfMessage: 
 *	
 *		LineLink *bodyOfMessage(MessTree *message);
 *	
 *		MessTree *message;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
LineLink *bodyOfMessage(MessTree *message)
{
	LineLink *line = NULL;

	if(message != NULL) {
		line = message->message;
	}
	return(line);
}

/***************************************************************************
 *	messageLabelSet: ĥ꡼ʤ˻ꤵ줿ǥ٥ĥդ
 *	
 *		void messageLabelSet(MessTree *message, XtPointer client_data);
 *	
 *		MessTree *message;	ʴ
 *		XtPointer client_data;
 *	
 *		
 ***************************************************************************/
void messageLabelSet(MessTree *message, XtPointer client_data)
{
	char *(*labelProc)(MessTree *message) = 
									(char *(*)(MessTree *))client_data;

	XtVaSetValues(message->treeWidget, XtNlabel, labelProc(message), NULL);
}
