/****************************************************************************
 *	xnmess.c: NIFTY SERVE ŻҲļɤġ
 *		
 *			Version 0.4.0	1998/09/21 -- 1998/10/14 
 *			Version 0.5.0	1998/01/21 -- 1999/05/16
 *			Version 0.5.1	1999/08/19
 *				Programed by Nobuyuki Maruichi
 *
 *	Note.
 *			SHIFT JIS Kanji Code / JIS X0208-1990
 *			Tab Size 4 / Shift Width = 4
 ***************************************************************************/

/***********************************************
 *	øɸ饤֥Υ󥯥롼ɥե
 ***********************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/***********************************************
 *	POSIX Υ󥯥롼ɥե
 ***********************************************/
# include <regex.h>

/***************************************************
 *	 X11/X Toolkit δŪʥ󥯥롼ɡե
 ***************************************************/
#include <X11/Xlocale.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>

/***************************************************
 *	 Atena Widget Υ󥯥롼ɡե
 ***************************************************/
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Text.h>
#include <X11/Xaw/TextSrc.h>
#include <X11/Xaw/TextSink.h>
#include <X11/Xaw/AsciiSrc.h>
#include <X11/Xaw/AsciiSink.h>

/***************************************************
 *	 ӥåȥޥå
 ***************************************************/
#include <X11/bitmaps/xlogo11>
#include "bitmaps/floppy.xbm"	
#include "bitmaps/floppy_m.xbm"	

/***************************************************
 *	 ѤΥ󥯥롼ɡե
 ***************************************************/
#include "file_sel.h"
#include "xfile.h"
#include "stringuty.h"
#include "luty.h"
#include "xnmess.h"
#include "mwxcduty.h"

/***************************************************
 *	 Хѿ
 ***************************************************/
char Filepath[4096];
char *localeName = NULL;
AppData app_data;

MessTitlesInfo *CurrentTitles = NULL;
MessTitlesInfo NormalTitles;
MessTitlesInfo TreeTitles;
const char *NullList[1] = {NULL};
static const char *TreeMarks[4] = {" ", "|", "+", "+"};
MessageNode *LocaleDict;

Pixmap mark, /* mark64, */ diskMark, diskDisable;
Widget topLevel;
Widget logList;
static int jaSourceEncodeType;
extern int (*jcodesets[])(unsigned const char **src_ptr, int old, int *type);
extern int (*jencodes[])(unsigned char *dest_ptr, int code, int old, int type);
extern int JaLocale;

extern FileSelctorInfo fileSelecterInfo;

static regex_t regExPattern;
int isMessageTop_Direct(const char *line);
int isMessageTop_Regex(const char *line);
int (*isMessageTop)(const char *line) = isMessageTop_Direct;

Boolean fileChangeText = False;
Boolean fileChangeWin  = True;

void preFileMenu(Widget w, XtPointer client_data, XtPointer garbage);
void load_chd(Widget w, XtPointer client_data, XtPointer call_data);
void loadSelectFinish(const char *dirName, const char *fileName);
void changeMessOrder(Widget w, XtPointer client_data, XtPointer call_data);
void changeMessageMode(Widget w, XtPointer client_data, XtPointer call_data);
MessTitlesInfo *loadLogFile(const char *filename);
void quit_proc(Widget w, XtPointer client_data, XtPointer call_data);

LineLink *messagePickup(int number, const MessTitlesInfo *info);
void messageAdd(MessTree *newMess, MessTree **root, MessTree *parent);
int haveAncestor(const char *line);
void MessRootDownTrace(MessTree *message, XtPointer client_data, 
				void (*MessProc)(MessTree *message, XtPointer client_data));
int MessNodeLevelTrace(MessTree *message, int relative, XtPointer client_data, 
				void (*MessProc)(MessTree *message, 
						int absolute, int relative, XtPointer client_data));
MessageNode *MarkDict = NULL;

void prevMessage(Widget w, XtPointer client_data, XtPointer call_data);
void nextMessage(Widget w, XtPointer client_data, XtPointer call_data);

/***************************************************************************
 --------------------------------------------------------------------------
	ץꥱ󡦥꥽
 --------------------------------------------------------------------------
 Name               Class              RepType         Default Value
 ----               -----              -------         -------------
 logFile            LogFile            String          NULL
 markString         MarkString         String          
											"mk0: \nmk1:|\nmk2:+\nmk3:+"
 messages           Messages           String          NULL
 help               Help               Boolean         FALSE
 treeMode           TreeMode           Boolean         FALSE
 verticalMargin     VerticalMargin     Int             28
 jencoding          Jencoding          String          ENCODING_DIR
 treeUsable         TreeUsable         Boolean         TRUE
 moveNewWindow      MoveNewWindow      Boolean         FALSE
 regexMessTop       RegexMessTop       String          
				"^[0-9][0-9][0-9][0-9][0-9]/[0-9][0-9][0-9][0-9][0-9] "
 regexMode          RegexMode          Boolean         False

	logFile :		ե̾ꤷƥץ󤹤뤿˻Ѥ
	markString:		ĥ꡼¤ɽ뤿ʸϿ
	messages:		å
	help:			إɽԤɤꤹե饰-h, --help ѡ
	treeMode: 		ĥ꡼⡼ɤ򼨤ե饰-t, --tree or -n, --number
	verticalMargin:	ӥ塼ΥǥեȤοľιԿ
	jencoding:		ܤΥбܸ쥨󥳡ɼ̤ξ
	treeUsable:		̤
	moveNewWindow:	ȯȤΤȤɥե饰
	regexMessTop:	ȯƬȽѤɽʸregexModeͭΤߡ
	regexMode:		ɽˤȯФԤɤ򼨤ե饰

 ***************************************************************************/
/* resource list */
static XtResource resources[] = {
	{
		XtNlogFile,
		XtCLogFile,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, file),
		XtRImmediate,
		(XtPointer) NULL
	}, 
	{
		XtNmarkString,
		XtCMarkString,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, markString),
		XtRImmediate,
		(XtPointer) "mk0: \n""mk1:|\n""mk2:+\n""mk3:+"
	}, 
	{
		XtNmessages,
		XtCMessages,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, messages),
		XtRImmediate,
		(XtPointer) NULL
	}, 
	{
		XtNhelp,
		XtCHelp,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, help),
		XtRImmediate,
		(XtPointer) FALSE,
	},
	{
		XtNsstdin,
		XtCSstdin,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, sstdin),
		XtRImmediate,
		(XtPointer) FALSE,
	},
	{
		XtNtreeMode,
		XtCTreeMode,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, treeMode),
		XtRImmediate,
		(XtPointer) FALSE,
	},
	{
		XtNverticalMargin,
		XtCVerticalMargin,
		XtRInt, 
		sizeof(Dimension),
		XtOffsetOf(AppData, verticalMargin),
		XtRImmediate,
		(XtPointer) 28,
	},
	{
		XtNjencoding,
		XtCJencoding,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, jencoding),
		XtRImmediate,
		(XtPointer) ENCODING_DIR,
	},
	{
		XtNtreeUsable, 
		XtCTreeUsable, 
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, treeUsable), 
		XtRImmediate,
		(XtPointer) TRUE,
	},
	{
		XtNmoveNewWindow,
		XtCMoveNewWindow,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, moveNewWindow),
		XtRImmediate,
		(XtPointer) FALSE,
	},
	{
		XtNregexMessTop,
		XtCRegexMessTop,
		XtRString,
		sizeof(String),
		XtOffsetOf(AppData, regexMessTop),
		XtRImmediate,
		(XtPointer) "^[0-9][0-9][0-9][0-9][0-9]/[0-9][0-9][0-9][0-9][0-9] "
	}, 
	{
		XtNregexMode,
		XtCRegexMode,
		XtRBoolean,
		sizeof(Boolean),
		XtOffsetOf(AppData, regexMode),
		XtRImmediate,
		(XtPointer) False
	},
};

/***************************************************************************
 *	ޥɥ饤󡦥ץ
 *		
 *	
 *		ץݡͥȡμࡡ̣͡
 *	
 *		-f <FILENAME> *logFileXrmoptionSepArg NULLե̾
 *	
 *		-t*treeMode XrmoptionNoArgTureĥ꡼ɽ
 *	
 *		--tree*treeMode XrmoptionNoArgTureĥ꡼ɽ
 *	
 *		-n*treeMode XrmoptionNoArgFalse ȯɽ
 *	
 *		--number*treeMode XrmoptionNoArgFalse ȯɽ
 *	
 *		-h*help XrmoptionNoArgTureإɽ
 *	
 *		--help*help XrmoptionNoArgTureإɽ
 *	
 *		
 ***************************************************************************/
/* Command-line options table */
static XrmOptionDescRec options[] = {
	{"-f", 			"*logFile", 		XrmoptionSepArg, NULL},
	{"-t", 			"*treeMode", 		XrmoptionNoArg, "True"},
	{"--tree", 		"*treeMode", 		XrmoptionNoArg, "True"},
	{"-n", 			"*treeMode", 		XrmoptionNoArg, "False"},
	{"--number",	"*treeMode", 		XrmoptionNoArg, "False"},
	{"-h",	 		"*help", 			XrmoptionNoArg, "True"},
	{"--help", 		"*help", 			XrmoptionNoArg, "True"},
	{"--", 			"*sstdin", 			XrmoptionNoArg, "True"},
};

/***************************************************************************
 *	FileMenuPanes: ե롦˥塼ѹ¤̻
 *		
 *	
 *		󷿤μ̻			˥塼̾			
 *	
 *		TopLineFilePane			--------				˥塼ʬ
 *	
 *		LoadFilePane			Load					ɤ߹
 *	
 *		MenuLine1FilePane		--------				˥塼ʬ
 *	
 *		NormalOrderPane			ȯɽ				ȯɽ
 *	
 *		TreeOrderPane			ĥ꡼ɽ				ĥ꡼¤ɽ
 *	
 *		MenuLine2FilePane		--------				˥塼ʬ
 *	
 *		ChangeTextPane			ǥƥȤѹ	
 *	
 *		ChnageNewWinPane		ǥɥ	
 *	
 *		MenuLine2FilePane		--------				˥塼ʬ
 *	
 *		QuitFilePane			Quit					λ
 *	
 *		
 ***************************************************************************/
enum _fileMenuPanes {
	TopLineFilePane = 0, LoadFilePane, MenuLine1FilePane, 
	NormalOrderPane, TreeOrderPane, MenuLine2FilePane,
	ChangeTextPane, ChnageNewWinPane, MenuLine3FilePane, 
	QuitFilePane
} FileMenuPanes;

/***************************************************************************
 *	appMenuInfo: ե롦˥塼
 *	
 *		ե˥塼ѡ¤
 *	
 *	
 *		ʤξ		å̾			
 *	
 *		ե롦		fileTopLine				˥塼ʬ
 *			˥塼	appMenuInfo[0]
 *	
 *		ե롦		fileLoad				ɤ߹ߡ
 *			˥塼	appMenuInfo[1]			load_chd()
 *	
 *		ե롦		fileMenuLine1			˥塼ʬ
 *			˥塼	appMenuInfo[2]
 *	
 *		ե롦		fileMakeSource			ȯɽ
 *			˥塼	appMenuInfo[3]			
 *	
 *		ե롦		fileMakeResource		ĥ꡼¤ɽ
 *			˥塼	appMenuInfo[4]			
 *	
 *		ե롦		fileMenuLine2			˥塼ʬ
 *			˥塼	appMenuInfo[5]
 *	
 *		ե롦		fileChangeText			ǥƥȤѹ
 *			˥塼	appMenuInfo[6]			
 *	
 *		ե롦		fileChangeWin			ǥɥ
 *			˥塼	appMenuInfo[7]			
 *	
 *		ե롦		fileMenuLine3			˥塼ʬ
 *			˥塼	appMenuInfo[8]
 *	
 *		ե롦		fileLoad				λ
 *			˥塼	appMenuInfo[9]			quit_proc()
 *	
 *	
 *		
 ***************************************************************************/
struct menu_data appMenuInfo[] = {
	{TypeSmeLine, "fileTopLine", 	NULL, NULL, 			NULL},
	{TypeSmeBSB,  "fileLoad", 		NULL, load_chd, 		NULL}, 
/*	{TypeSmeBSB,  "fileSave", 		NULL, save_chd, 		NULL},*/
/*	{TypeSmeBSB,  "fileClear", 		NULL, partsClearAll, 	&CurrentParts}, */
	{TypeSmeLine, "fileMenuLine1", 	NULL, NULL, 			NULL},
	{TypeSmeBSB,  "fileNumOrder", 	NULL, changeMessOrder, 	&NormalTitles},
	{TypeSmeBSB,  "fileTreeOrder", 	NULL, changeMessOrder, 	&TreeTitles},
	{TypeSmeLine, "fileMenuLine2", 	NULL, NULL, 			NULL},
	{TypeSmeBSB,  "fileChangeText",	NULL, changeMessageMode, &fileChangeText},
	{TypeSmeBSB,  "fileChangeWin",	NULL, changeMessageMode, &fileChangeWin},
	{TypeSmeLine, "fileMenuLine3", 	NULL, NULL, 			NULL},
	{TypeSmeBSB,  "fileQuit", 		NULL, quit_proc, 		NULL},
	{EOF, NULL, NULL, NULL, NULL}
};

/***************************************************************************
 *	
 *	
 *	
 *		С				Ư				
 *	
 *		fileMenu.menuButton		˥塼ܥ		makeMenus() 
 *								Υå		
 *	
 *		fileMenu.menu			˥塼			makeMenus() 
 *								å		
 *	
 *		fileMenu.menuName		˥塼δ̾	˻
 *	
 *		fileMenu.num			˥塼ܤο	
 *	
 *		fileMenu.popup()		ݥåץå״ؿ	
 *	
 *		fileMenu.popdown		ݥåץؿ	
 *	
 *		fileMenu.info			˥塼ܾ	
 *	
 *		
 *		makeMenus() ǥ˥塼뤿ξ
 *		
 ***************************************************************************/
struct menuData fileMenu = {
	NULL,
	NULL,
	"fileMenu", 
	sizeof(appMenuInfo) / sizeof(appMenuInfo[0]) - 1,
	preFileMenu, 
	NULL, 
	appMenuInfo
};

void loadSelectFinish(const char *dirName, const char *fileName);

fSelectorMenuInfo loadSelectorInfomation = {
	&filePickupPaneInfo[1], &fileSortPaneInfo[1], loadSelectFinish
};

/***************************************************************************
 *	load_chd: 
 *	
 *		void load_chd(Widget w, 
 *								XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;	
 *		XtPointer client_data;	
 *		XtPointer call_data;	
 *	֤
 *		
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		ե롦		fileLoad				ɤ߹ߡ
 *			˥塼	topMenuInfo[1]			load_chd()
 *	
 *		
 *		
 ***************************************************************************/
/*ARGSUSED*/
void load_chd(Widget w, XtPointer client_data, XtPointer call_data)
{
	/*chdir(fileSelecterInfo.searchingPath);*/
	fileSelecterInfo.searchingPath = Filepath;
	chdir(fileSelecterInfo.searchingPath);
}

/***************************************************************************
 *	loadSelectFinish: ե롦쥯򤷤ե̾ꤹ
 *	
 *		void loadSelectFinish(const char *dirName, const char *fileName);
 *	
 *		const char *dirName;	ǥ쥯ȥ̾
 *		const char *fileName;	ե̾
 *	
 *		
 ***************************************************************************/
/*ARGSUSED*/
void loadSelectFinish(const char *dirName, const char *fileName)
{
	char filepath[4096];

	sprintf(filepath, "%s/%s", dirName, fileName);
	CurrentTitles = loadLogFile(filepath);
}

/***************************************************************************
 *	preFileMenu: ե롦˥塼ġԲɽ
 *	
 *		static void preFileMenu(Widget w, 
 *								XtPointer client_data, XtPointer garbage);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	˥塼ֹ
 *		XtPointer garbage;		̤
 *	
 *		
 ***************************************************************************/
/* ARGSUSED */
void preFileMenu(Widget w, XtPointer client_data, XtPointer garbage)
{
	Boolean nSensitive;
	Boolean tSensitive;
	struct menuData *menuInfo = (struct menuData*) client_data;

	nSensitive = (CurrentTitles != &NormalTitles && NormalTitles.titles != NULL);
	tSensitive = (CurrentTitles != &TreeTitles && TreeTitles.titles != NULL);
	/* XtSetSensitive((menuInfo->info+LoadFilePane)->myWidget, sensitive); */
	/*  */
	XtSetSensitive((menuInfo->info+NormalOrderPane)->myWidget, nSensitive);
	XtSetSensitive((menuInfo->info+TreeOrderPane)->myWidget, tSensitive);
	/*  */
	XtSetSensitive((menuInfo->info+ChangeTextPane)->myWidget, 
												app_data.moveNewWindow);
	XtSetSensitive((menuInfo->info+ChnageNewWinPane)->myWidget, 
												!app_data.moveNewWindow);
}

/***************************************************************************
 *	LabelPixmaps: ٥ѤΥԥޥåפޤ
 *	
 *		void LabelPixmaps(Display *display, Drawable drawable);
 *	
 *		Display *display;
 *		Drawable drawable;
 *	֤
 *		
 *	
 *		ʲΥ٥ѤΥԥޥåפ
 *		  եåԥǥΥޡ̾
 *		  եåԥǥΥޡԲġ
 *		  åޡxlogo11
 *		
 ***************************************************************************/
void LabelPixmaps(Display *display, Drawable drawable)
{
	diskMark = XCreateBitmapFromData(display, drawable, 
			floppy_bits, floppy_width, floppy_height);

	diskDisable = XCreateBitmapFromData(display, drawable, 
			floppy_m_bits, floppy_m_width, floppy_m_height);

	mark = XCreateBitmapFromData(XtDisplay(topLevel), 
						RootWindowOfScreen(XtScreen(topLevel)), 
						xlogo11_bits, xlogo11_width, xlogo11_height);

#ifdef xlogo64_width
	mark64 = XCreateBitmapFromData(XtDisplay(topLevel), 
						RootWindowOfScreen(XtScreen(topLevel)), 
						xlogo64_bits, xlogo64_width, xlogo64_height);
#endif /*xlogo64_width*/
}

/***************************************************************************
 *	finishedAndDestroy: åȤݥåץ󤷤˲
 *	
 *		void finishedAndDestroy(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	˲륦å
 *		XtPointer call_data;	̤
 *	
 *		
 *	
 *		ʤξ		å̾			
 *	
 *		꥽	finishedAndDestroy		ݥåץ˴
 *	
 *		
 ***************************************************************************/
void finishedAndDestroy(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtPopdown((Widget)client_data);
	XtDestroyWidget((Widget)client_data);
}

/***************************************************************************
 *	releaseMemory: åȤݥåץ󤷤˲
 *	
 *		void releaseMemory(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				̤
 *		XtPointer client_data;	˲륦å
 *		XtPointer call_data;	̤
 *	
 *		
 *		
 ***************************************************************************/
void releaseMemory(Widget w, XtPointer client_data, XtPointer call_data)
{
	XtFree((XtPointer)client_data);
}

/***************************************************************************
 *	nullTerminatedStringList: NULL üʸƤɽ
 *	
 *		void nullTerminatedStringList(const char **strings);
 *	
 *		const char **strings;	NULL üʸ
 *	֤
 *		ʤ
 *	
 *		ǥХåѤ NULL üʸƤɽ롣
 *		
 ***************************************************************************/
void nullTerminatedStringList(const char **strings)
{
	int counter;

	for(counter = 0;*(strings + counter) != NULL;++counter) {
		printf("%5d  %s", counter, *(strings + counter));
	}
}

/***************************************************************************
 *	jaSourceEncode: եܸΥ󥳡ɼ̤Ͽ
 *	
 *		int jaSourceEncode(int encode);
 *	
 *		int encode;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
int jaSourceEncode(int encode)
{
	if(encode != EOF) {
		jaSourceEncodeType = encode;
	}
	return(jaSourceEncodeType);
}

/***************************************************************************
 *	newJcodeCnv: ΰݤܸ쥨󥳡Ѵʸ򥳥ԡ
 *	
 *		char *newJcodeCnv(char *oldEncodeString);
 *	
 *		char *oldEncodeString;	쥨󥳡ɤǤʸ
 *	֤
 *		NULL:		顼
 *		NULLʳ:	ݤѴʸΥХåե
 *	
 *		ΰݤܸ쥨󥳡Ѵʸ򥳥ԡ
 *		
 ***************************************************************************/
char *newJcodeCnv(char *oldEncodeString)
{
	char *result;
	char *lineEnd;

	result = string2otherEncodeNewString(oldEncodeString, 
						jcodesets[jaSourceEncodeType], jencodes[JaLocale]);
	lineEnd = result + strcspn(result, "\n\r");
	*lineEnd     = '\0';
	/* *(lineEnd+1) = '\0'; */
	return(result);
}

/***************************************************************************
 *	MessCreate: ĥ꡼ΥåΣȯʬΥΡɤݤ
 *	
 *		MessTree *MessCreate(LineLink *messageTop);
 *	
 *		LineLink *messageTop;	ȯʬʸΥ󥯥ꥹ
 *	֤
 *		
 *	
 *		Ρɤκ
 *		
 *		  ʤɲäΡɤ˻ҥåȤ¸ߤʤ
 *		
 *		ʹĥ꡼ΥΡɨ
 *		
 *		 number ġġġġġåȯֹ
 *		
 *		 messageåƬԨġĽüޤ
 *		
 *		 treeWidget  NULL ġġ̤ѡ
 *		
 *		 parent_ptr  NULL 
 *		
 *		 child_ptr NULL 
 *		
 *		prev_ptr NULL 
 *		
 *		next_ptr NULL 
 *		
 *		
 *		
 ***************************************************************************/
MessTree *MessCreate(LineLink *messageTop)
{
	int number = EOF;
	LineLink *message = messageTop;
	MessTree *alloc_ptr = NULL;
	
	for(;message != NULL && number == EOF;message = message->next_ptr) {
		number = numberOfMessage(message->string, NULL, NULL);
	}
	if(number != EOF) {
		/* printf("%s", message->string); */
		alloc_ptr = (MessTree*)XtMalloc(sizeof(MessTree));
		if(alloc_ptr != NULL) {
			alloc_ptr->number     = number;
			alloc_ptr->message    = messageTop;
			alloc_ptr->treeWidget = NULL;
			alloc_ptr->parent_ptr = NULL;
			alloc_ptr->child_ptr  = NULL;
			alloc_ptr->prev_ptr   = NULL;
			alloc_ptr->next_ptr   = NULL;
		}
#ifndef	DEBUG_FINISHED
	} else {
		printf("MessCreate() error.:%s", messageTop->string);
#endif	/*DEBUG_FINISHED*/
	}
	return(alloc_ptr);
}

/***************************************************************************
 *	messageTitles: åΥȥʸ򤵤ݥȤƺ
 *	
 *		char **messageTitles(LineLink **messages, 
 *							char *(*strproc)(char *string));
 *	
 *		LineLink **messages;
 *		char *(*strproc)(const char *string);
 *	֤
 *		NULL		顼
 *		NULLʳ	ʸNULLü
 *	
 *		åΥȥʸ򤵤ݥȤƺޤ
 *		
 *		 messages ϡʲΤ褦ʥǡޤƬԤ
 *		åΥȥ뤬ޤޤƤޤ
 *		
 *		
 *		messagesġݥѤ˳Ƥ줿ΰؤ
 *		
 *		ʸƬʸ
 *		
 *		ʸبʸبʸب
 *		źΥݥ󥿨
 *		       
 *		źΥݥ󥿨
 *		NULL
 *		
 *		ʸبʸبʸب
 *		źΥݥ󥿨
 *		       
 *		
 *		NULL
 *		 ǸΥݥ NULL ݥ
 *		
 *		
 *		messages ϡNULL ü˻ĤᡢޤǤ򥫥Ȥɬפ
 *		ο򥫥Ȥޤǡ֤ѤΥݤޤ
 *		
 *		θ塢messages ʸ (*strproc)() ǡ
 *		֤ͤΥꥹȤϤޤ
 *		
 *		
 *		titlesĥݥѤ˥ΰؤ֤͡
 *		
 *		
 *		messages
 *		
 *		titles[0] 
 *		
 *		titles[1] s[0]
 *		 strproc()
 *		s[1]ʸ
 *		
 *		titles[n] 
 *		ʸبʸبʸب
 *		s[n]
 *		       
 *		
 *		NULL
 *		 Ǹ NULL ݥ
 *		
 *		 Ǹ NULL ݥ
 *		
 *		
 *		(*strproc)() ȤƤϡѰդ strdirect()  XtNewString() 
 *		Ǥޤstrdirect() ѤȸʸؤȤǺǾΥ
 *		̤ǺѤࡣXtNewString() ѤȿʥݤƤ
 *		ΤǸʸ¸ߤʤʤäƤХˤʤʤ
 *	Ȼ
 *		char *strdirect(char *string);
 *		String XtNewString(string);
 *		
 ***************************************************************************/
char **messageTitles(LineLink **messages, char *(*strproc)(char *string))
{
	int counter;
	int num;
	char **titles = NULL;

	num = arrayCount((XtPointer)messages);
	/* printf("%d\n", num); */
	if(num > 0) {
		titles = (char**)XtMalloc(sizeof(char*) * (num + 1));
	}
	if(titles != NULL) {
		*titles = NULL;
	}
	for(counter = 0;titles != NULL && counter < num;++counter) {
		/* printf("%d:%p\n", counter, *(messages + counter)); */
		if(*(messages + counter) != NULL) {
			*(titles + counter) = strproc((*(messages + counter))->string);
#ifndef DEBUG_FINISHED
			numberOfMessage((*(messages + counter))->string, NULL, NULL);
			if((*(messages + counter))->next_ptr != NULL && 
					(*(messages + counter))->next_ptr->string != NULL) {
				haveAncestor((*(messages + counter))->next_ptr->string);
			}
#endif /*DEBUG_FINISHED*/
			/* printf("%05d %s", counter, *(titles + counter)); */
		}
		*(titles + counter + 1) = NULL;
	}
	if(titles != NULL) {
		*(titles + num) = NULL;
	}
	return(titles);
}

/***************************************************************************
 *	messageNumOrderTitles: ȯֹǥȥʸ
 *	
 *		MessTitlesInfo messageNumOrderTitles(
 *					LineLink **messages, char *(*strproc)(char *string));
 *	
 *		LineLink **messages;
 *		char *(*strproc)(char *string);	ʸѴؿJIS/EUS/SJISѴ
 *	֤
 *		ȥꥹȾ
 *	
 *		֤ͤϡʲΤ褦ʾĹ¤ΤǤ롣
 *		
 *		ȥꥹȾ󨬨
 *		
 *		message 
 *		
 *		titles
 *		
 *		 numȯ
 *		
 *		 counter
 *		
 *		 (*strproc)() 
 *		
 *		(*messagePickup)()
 *		
 *		
 *		
 *		
 *		ȥʸ󡡡
 *		char* 
 *		ȯơ
 *		titles[0] LineLink* ˨
 *		
 *		titles[1] s[0]
 *		 strproc()
 *		s[1]ʸ
 *		
 *		titles[n] 
 *		ʸبʸبʸب
 *		s[n]
 *		       
 *		
 *		NULL
 *		 Ǹ NULL ݥ
 *		
 *		 Ǹ NULL ݥ
 *		
 *		
 *		
 ***************************************************************************/
MessTitlesInfo messageNumOrderTitles(LineLink **messages, char *(*strproc)(char *string))
{
	int counter;
	MessTitlesInfo treeTitles;
	
	treeTitles.counter = 0;
	treeTitles.strproc = strproc;
	treeTitles.num = arrayCount((XtPointer)messages);
	treeTitles.messagePickup = messagePickup;
	treeTitles.titles = NULL;
	if(treeTitles.num > 0) {
		 /*	åΥȥʸ򤵤ݥȤƺ */
		treeTitles.titles = messageTitles(messages, strproc);
		treeTitles.messages = 
			(LineLink**)XtMalloc(sizeof(LineLink*) * (treeTitles.num + 1));
		for(counter = 0;counter < treeTitles.num;++counter) {
			*(treeTitles.messages + counter) = *(messages + counter);
		}
		*(treeTitles.messages + counter) = NULL;
	}
	return(treeTitles);
}

/***************************************************************************
 *	MessNumber: ȯֹӤ̤֤Хåؿ
 *	
 *		XtPointer MessNumber(MessTree *message, XtPointer client_data);
 *	
 *		MessTree *message;		ȯĥ꡼ξ
 *		XtPointer client_data;	ȯֹint ѿˤؤݥ
 *	֤
 *		NULLʤ顧	פʤä
 *		NULLʳ	פ֤ͤϡ裱Ρmessage 
 *	
 *		δؿϡʲΤ褦ˡ
 *		parent = (MessTree*)MessSearch(root, &parentNo, MessNumber);
 *		ؿʻѤȯֹ渡Τ˻Ѥ롣
 *		
 ***************************************************************************/
XtPointer MessNumber(MessTree *message, XtPointer client_data)
{
	XtPointer result = NULL;
	int number = *((int*)client_data);

	if(message != NULL && message->number == number) {
		result = (XtPointer)message;
	}
	return(result);
}

/***************************************************************************
 *	makeMessageTree: åĥ꡼¤
 *	
 *		MessTree *makeMessageTree(LineLink **messages);
 *	
 *		LineLink **messages;	ȯʸ󥯤Ƭؤ
 *	֤
 *		NULL		顼
 *		NULLʳ	åĥ꡼κܤι¤Τؤݥ󥿡
 *	
 *		åĥ꡼¤ؤΥ󥯤ļʻȹ¤ΤǺ
 *		롣
 *		
 *		 messages ϡʲΤ褦ʥǡޤ
 *		
 *		
 *		messagesġݥѤ˳Ƥ줿ΰؤ
 *		
 *		ʸƬʸ
 *		
 *		ʸبʸبʸب
 *		źΥݥ󥿨
 *		       
 *		źΥݥ󥿨
 *		NULL
 *		
 *		ʸبʸبʸب
 *		źΥݥ󥿨
 *		       
 *		
 *		NULL
 *		 ǸΥݥ NULL ݥ
 *		
 *		
 *		Ǥϡȯ椫鸵ȯ򼨤ơȯĥ꡼
 *		ˤ븵ȯȥ󥯤ĥäơʲΤ褦ʥĥ꡼¤롣
 *		
 *		MessTree ȯΥĥ꡼¤
 *		
 *		ȯĥ꡼κܨȯ
 *		
 *		 number  number 
 *		
 *		 messageʸ󨭡 messageʸ
 *		
 *		 treeWidget  treeWidget 
 *		
 *		 parent_ptr  NULL  parent_ptr 
 *		
 *		 child_ptr child_ptr   NULL 
 *		
 *		prev_ptr NULL prev_ptr NULL 
 *		
 *		next_ptr NULL next_ptr
 *		
 *		
 *		
 *		ȯ
 *		
 *		 number 
 *		
 *		 messageʸ
 *		
 *		 treeWidget 
 *		
 *		 parent_ptr 
 *		
 *		 child_ptr   NULL 
 *		
 *		prev_ptr
 *		
 *		next_ptr NULL 
 *		
 *		
 *	
 *		
 *	Ȼ
 *		
 *		
 ***************************************************************************/
MessTree *makeMessageTree(LineLink **messages)
{
	int num;
	int counter;
	int parentNo = EOF;
	MessTree *root = NULL;
	MessTree *parent = NULL;
	MessTree *currentMessage = NULL;

	/* ȯ */
	num = arrayCount((XtPointer)messages);
	/* printf("%d\n", num); */
	/* ȯʬ롼פ */
	for(counter = 0;counter < num;++counter) {
		if(*(messages + counter) != NULL) {
			/* ȯ¸ߤ */
			currentMessage = MessCreate(*(messages + counter));	/* Ρɳ */
			if(root != NULL && (*(messages + counter))->next_ptr != NULL && 
						(*(messages + counter))->next_ptr->string != NULL) {
				/* ȯˣܤ */
				parentNo = haveAncestor((*(messages + counter))->next_ptr->string);
				parent = (MessTree*)MessSearch(root, &parentNo, MessNumber);
			} else {
				parent = NULL;
			}
			if(currentMessage != NULL) {
				/* ȯʤΤǡ롼Ȥɲä */
				messageAdd(currentMessage, &root, parent);
			}
		}
	}
	return(root);
}

/***************************************************************************
 *	MessLevelCount: ȯο򥫥Ȥ
 *	
 *		void MessLevelCount(MessTree *message, XtPointer client_data);
 *	
 *		MessTree *message;
 *		XtPointer client_data;
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void MessLevelCount(MessTree *message, XtPointer client_data)
{
	int *level = (int*)client_data;

	++*level;
}


/***************************************************************************
 *	MessTreeMarks: ƵƽФǸƤᤵƥĥ꡼¤ޡ
 *	
 *		void MessTreeMarks(MessTree *message, 
 *					int absolute, int relative, XtPointer client_data);
 *	
 *		MessTree *message;
 *		int absolute;
 *		int relative;
 *		XtPointer client_data;
 *	֤
 *		ʤ
 *	
 *		ʲΤ褦ʥޡѤޤ
 *		
 *		ѿ̻ҨISO8850-1 JIS X0208 
 *		
 *		TreeMarks[0] mk0     " "       ""   
 *		
 *		TreeMarks[1] mk1     "|"       ""   
 *		
 *		TreeMarks[2] mk2     "+"       ""   
 *		
 *		TreeMarks[3] mk3     "+"       ""   
 *		
 *		ISO8859-1 ϡǥեȤ "C" Ǥ
 *		JIS X0208 ϡܸEUC  "ja_JP.ujis" Ǥ
 *		
 ***************************************************************************/
void MessTreeMarks(MessTree *message, int absolute, int relative, XtPointer client_data)
{
	int pattern;
	char *buffer = client_data;

	pattern = (message->next_ptr != NULL) + ((relative == 0) << 1);
	sprintf(buffer+(absolute*2), "%2.2s", TreeMarks[pattern]);
}

/***************************************************************************
 *	MessTreeList: ĥ꡼¤ɽǤΥȥꥹȤΣʬ
 *	
 *		void MessTreeList(MessTree *message, XtPointer client_data);
 *	
 *		MessTree *message;		ȯĥ꡼ξ
 *		XtPointer client_data;	ȥꥹ
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void MessTreeList(MessTree *message, XtPointer client_data)
{
	int level = 0;
	MessTitlesInfo *treeTitles = (MessTitlesInfo*)client_data;
	char messageBuffer[4096];

	if(treeTitles->counter >= 0 && treeTitles->counter < treeTitles->num) {
		/* ʸɽ */
		MessNodeLevelTrace(message, 0, messageBuffer, MessTreeMarks);
		sprintf(messageBuffer+strlen(messageBuffer), "%s",
			treeTitles->strproc(message->message->string));
			/* treeTitles->strproc((message + treeTitles->counter)->message->string)); */
		*(treeTitles->titles + treeTitles->counter) = XtNewString(messageBuffer);
		*(treeTitles->messages + treeTitles->counter) = message->message;
		++treeTitles->counter;
		*(treeTitles->titles + treeTitles->counter) = NULL;
		*(treeTitles->messages + treeTitles->counter) = NULL;
	}
}

/***************************************************************************
 *	messageTreeTitles: ĥ꡼¤ɽǤΥȥꥹȤ
 *	
 *		MessTitlesInfo messageTreeTitles(LineLink **messages, 
 *										char *(*strproc)(char *string));
 *	
 *		LineLink **messages;
 *		char *(*strproc)(char *string);	ʸѴؿJIS/EUS/SJISѴ
 *	֤
 *		ȥꥹȾ
 *	
 *		֤ͤϡʲΤ褦ʾĹ¤ΤǤ롣
 *		
 *		ȥꥹȾ󨬨
 *		
 *		message 
 *		
 *		titles
 *		
 *		 numȯ
 *		
 *		 counterġġġĨĨtitles/messages 
 *		Υ󥿡źn 
 *		 (*strproc)() 롣
 *		
 *		(*messagePickup)()
 *		
 *		
 *		
 *		
 *		ȥʸ󡡡
 *		char* 
 *		ȯơ
 *		titles[0] LineLink* ˨
 *		
 *		titles[1] s[0]
 *		 strproc()
 *		s[1]ʸ
 *		
 *		titles[n] 
 *		ʸبʸبʸب
 *		s[n]
 *		       
 *		
 *		NULL
 *		 Ǹ NULL ݥ
 *		
 *		 Ǹ NULL ݥ
 *		
 *	Ȼ
 *		MessTopTrace2: ĥ꡼¤ȥ졼
 *		
 *		
 ***************************************************************************/
MessTitlesInfo messageTreeTitles(LineLink **messages, char *(*strproc)(char *string))
{
	MessTree *root;
	MessTitlesInfo treeTitles;

	root = makeMessageTree(messages);	/* åĥ꡼¤ */
	treeTitles.counter = 0;
	treeTitles.num = arrayCount((XtPointer)messages);
	treeTitles.strproc = strproc;
	treeTitles.messagePickup = messagePickup;
	treeTitles.titles = NULL;
	/* printf("%d\n", num); */
	if(treeTitles.num > 0) {
		/* ȥʸγ */
		treeTitles.titles   = (char**)XtMalloc(sizeof(char*) * (treeTitles.num + 1));
		treeTitles.messages = (LineLink**)XtMalloc(sizeof(LineLink*) * (treeTitles.num + 1));
	}
	if(treeTitles.titles != NULL) {
		/* ĥ꡼¤ʾ夫ľϤͥŪˡ˥ȥ졼 */
		MessTopTrace2(root, &treeTitles, MessTreeList);
	}
	return(treeTitles);
}

/***************************************************************************
 *	isMessageTop_Direct: NIFTY SERVE ŻҲļȯϹԤȽꤹ
 *	
 *		int isMessageTop_Direct(const char *line);
 *	
 *		const char *line;	ʸ
 *	֤
 *		FALSE:		ꤵ줿ʸϡȯϹԤǤʤ
 *		TRUE:		ꤵ줿ʸϡȯγϹԤǤ
 *	
 *		ɽǤϡ'[0-9][0-9][0-9][0-9][0-9]/[0-9][0-9][0-9][0-9][0-9] '
 *		ӤΤƱǤ
 *		
 *	ջ
 *		NIFTY SERVE ŻҲļΥΥեޥåȤ˰¸ؿ
 *		ѤʤΤؤ֤Ƥ档
 *		ɽˤȽؤ֤ͽꤷƤ롣
 *		
 ***************************************************************************/
int isMessageTop_Direct(const char *line)
{
	int result = TRUE;
	int counter;

	for(counter = 0;result && *(line + counter) != '\0' && counter < 5;++counter)
		result = result && isdigit(*(line + counter));

	if(result && *(line + counter) != '\0' && counter == 5)
		result = result && (*(line + counter) == '/');
	else
		result = FALSE;

	for(counter = 6;result && *(line + counter) != '\0' && counter < 11;++counter)
		result = result && isdigit(*(line + counter));

	if(result && *(line + counter) != '\0' && counter == 11)
		result = result && (*(line + counter) == ' ');
	else
		result = FALSE;

	return(result);
}

/***************************************************************************
 *	isMessageTop_Regex: NIFTY SERVE ŻҲļȯϹԤȽꤹ
 *	
 *		int isMessageTop_Regex(const char *line);
 *	
 *		const char *line;	ʸ
 *	֤
 *		FALSE:		ꤵ줿ʸϡȯϹԤǤʤ
 *		TRUE:		ꤵ줿ʸϡȯγϹԤǤ
 *	
 *		ɽǤϡ'[0-9][0-9][0-9][0-9][0-9]/[0-9][0-9][0-9][0-9][0-9] '
 *		ӤΤƱǤ
 *		
 *	ջ
 *		NIFTY SERVE ŻҲļΥΥեޥåȤ˰¸ؿ
 *		ѤʤΤؤ֤Ƥ档
 *		ɽˤȽؤ֤ͽꤷƤ롣
 *		
 ***************************************************************************/
int isMessageTop_Regex(const char *line)
{
	return(!regexec(&regExPattern, line, 0, NULL, 0));
}

/***************************************************************************
 *	numberOfMessage: ȯֹμ
 *	
 *		int numberOfMessage(const char *line, char *idString, char *titleString);
 *	
 *		const char *line;
 *		char *idString;
 *		char *titleString;
 *	֤
 *		
 *	
 *		
 *	ջ
 *		NIFTY SERVE ŻҲļΥΥեޥåȤ˰¸ؿ
 *		ѤʤΤؤ֤Ƥ档
 *		
 ***************************************************************************/
int numberOfMessage(const char *line, char *idString, char *titleString)
{
	int result = EOF;
	int counter;
	int number, endNumber, pos, panes;
	char tmp1;
	char id[80] = "", handle[20] = "", title[80] = "";

	/* printf("\n%s", line); */
	if(strlen(line) < 29 && strlen(line) > 80 && !isMessageTop(line)) {
		return(FALSE);
	}
	panes = sscanf(line, "%5d%c%5d%8s%16s%n%s", 
					&number, &tmp1, &endNumber, id, &handle, &pos, title);
	/* printf("panes = %d, pos=%d ", panes, pos); */
	/* printf("\"%05d\"\"%c\"\"%05d\"\"%s\"\"%s\"", number, tmp1, endNumber, id, title); */
	if(panes >= 5) {
		if(tmp1 == '/' /* && pos == 28)*/) {
			result = number;
			if(idString != NULL) {
				sprintf(idString, "%8.8s", id);
			}
			if(titleString != NULL) {
				sprintf(titleString, "%.41s", title);
			}
		} else {
			result = EOF;
		}
	}
	return(result);
}

/***************************************************************************
 *	haveAncestor: ȯֹ
 *	
 *		int haveAncestor(const char *line);
 *	
 *		const char *line;
 *	֤
 *		EOF:		ȯåΤȤΥ顼
 *		EOFʳ:	ȯֹ
 *	
 *		
 ***************************************************************************/
int haveAncestor(const char *line)
{
	int result = TRUE;
	int counter;
	int mes, pos, panes, parent;
	char tmp1, tmp2, tmp3[4], tmp4, tmp5[3];
	char dateString[80], timeString[80];

	/* printf("\n%s", line); */
	if(strlen(line) < 20 && strlen(line) > 60) {
		return(EOF);
	}
	if(*line != '(' || (!isdigit(*(line+1)) && *(line+1) != ' ') || 
							!isdigit(*(line+2)) || *(line+3) != ')') {
		for(counter = 4;*(line + counter) != '\0' && counter < 7;++counter)
			result = result && (*(line + counter) ==  ' ');
	}
	panes = sscanf(line, "%c%02d%c%8s%5s%n%05d", 
					&tmp1, &mes, &tmp2, 
					dateString, timeString, &pos, &parent);
	/*printf("panes = %d, pos = %d ", panes, pos);*/
	/*printf("\"%c\"\"%2d\"\"%c\"\"%s\"\"%s\"", tmp1, mes, tmp2, dateString, timeString);*/
	if(panes >= 5) {
		if(!(tmp1 == '(' && tmp2 == ')' && strcmp(tmp3, "   ") == 0 &&
				strlen(dateString) == 8 && tmp4 == ' ' && 
				strlen(timeString) == 5 && pos == 21)) {
			result = FALSE;
		}
	}
	if(panes >= 6) {
		/* printf("parent = %d\n", parent); */
		result = TRUE;
	} else {
		result = FALSE;
	}
	return((result)?(parent):(EOF));
}

/***************************************************************************
 *	countMessages: NIFTY SERVE ΥΥ󥯥ǡȯ򥫥
 *	
 *		int countMessages(LineLink *strings);
 *	
 *		LineLink *strings;
 *	֤
 *		NIFTY SERVE ΥΥ󥯥ǡȯ
 *	
 *		NIFTY SERVE ΥΥ󥯥ǡȯ򥫥
 *		
 ***************************************************************************/
int countMessages(LineLink *strings)
{
	int counter;
	
	counter = 0;
	while(strings != NULL) {
		if(isMessageTop(strings->string)) {
			++counter;
			/* printf("%s", strings->string); */
		}
		strings = strings->next_ptr;
	}
	return(counter);
}

/***************************************************************************
 *	readFile: ꤵ줿ե뤫󥯥ǡ
 *	
 *		LineLink *readFile(const char *filename);
 *	
 *		const char *filename;	ե̾ʥѥ̾
 *	֤
 *		NULL:		顼
 *		NULLʳ:	󥯥ǡ
 *	
 *		֤ͤ LineLink ݥ󥿤ؤǡ¤
 *		
 *		
 *		֤ͨġեΤʸ󥯤ؤ
 *		
 *		
 *		
 *		ʸبʸبʸبʸب
 *		
 *		        NULL
 *		
 *		
 *		
 ***************************************************************************/
LineLink *readFile(const char *filename)
{
	LineLink *fileLines = NULL;
	FILE *fp;

	if((fp = fopen(filename, "r")) != NULL) {
		fileLines = file2lines(fp);
		fclose(fp);
	}
	return(fileLines);
}

/***************************************************************************
 *	messagesCutter: ե椫åڤʬ
 *	
 *		LineLink **messagesCutter(LineLink *logFile);
 *	
 *		LineLink *logFile;
 *	֤
 *		
 *	
 *		 logFile λؤǡη
 *		
 *		
 *		logFile ġեΤʸ󥯤ؤ
 *		
 *		
 *		
 *		ʸبʸبʸبʸب
 *		
 *		        NULL
 *		
 *		
 *		֤ͤϡʲΤ褦ʥǡˤʤޤ
 *		
 *		
 *		messagesġݥѤ˳Ƥ줿ΰؤ
 *		
 *		ʸƬʸ
 *		
 *		ʸبʸبʸب
 *		źΥݥ󥿨
 *		       
 *		źΥݥ󥿨
 *		NULL
 *		
 *		ʸبʸبʸب
 *		źΥݥ󥿨
 *		       
 *		
 *		NULL
 *		 ǸΥݥ NULL ݥ
 *		
 *		
 *		
 ***************************************************************************/
LineLink **messagesCutter(LineLink *logFile)
{
	int num;
	int counter, lines;
	LineLink **messages, *previousMess = NULL, *previousLine = NULL;

	num = countMessages(logFile);		/* ȯ򥫥Ȥ */
	/* printf("---%d---\n", num); */
	messages = (LineLink**)XtMalloc(sizeof(LineLink*) * num + 1);
	*messages = NULL;
	for(counter = 0, lines = 0;logFile != NULL && counter < num;++lines) {
		if(isMessageTop(logFile->string)) {
			*(messages + counter) = logFile;
			if(previousMess != NULL && previousLine != NULL) {
				previousLine->next_ptr = NULL;
			}
			previousMess = *(messages + counter);
			++counter;
			*(messages + counter) = NULL;
		}
		previousLine = logFile;
		logFile = logFile->next_ptr;
	}
	return(messages);
}

#ifdef	OLD_IMPREMENT
/***************************************************************************
 *	getMessages: 
 *	
 *		LineLink **getMessages(const char *filename);
 *	
 *		const char *filename;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
LineLink **getMessages(const char *filename)
{
	LineLink *logFile;
	LineLink **messages;
	
	logFile = readFile(filename);
	messages = messagesCutter(logFile);
}
#endif	/*OLD_IMPREMENT*/

/***************************************************************************
 *	createLogEditor: ɽ⡼ɤޤϡԽ⡼ɤǥ򳫤
 *	
 *		void createLogEditor(Widget parent, char *cnvTextString, 
 *						Widget *editor, CurrentMessageInfo *messageInfo);
 *	
 *		Widget parent;			ƥå
 *		char *cnvTextString;	ɽѤΥɤѴѤΥȥʸ
 *		Widget *editor;			Խʬ򼨤ݥ󥿡ɽ⡼:NULL
 *		CurrentMessageInfo *messageInfo;	ɽΥȥåȤξ
 *	֤
 *		ʤ
 *	
 *		ɽѤΥɥơɽ⡼ɤޤϡԽ⡼ɤǥ
 *		ޤǺΤϡʲΥĥ꡼¤ʬǤ
 *		
 *		
 *		[ĥ꡼¤] 饹̾ 󥹥̾	Ư					
 *		
 *		  TopLevelShell  logShell									
 *		    Paned  logPaned				˥塼ʸʬʬ䨭
 *		        Paned  logTools			˥塼ܤ		
 *		            Command  logQuit	Ĥ					
 *		            Label  logTitle		ȯȥ			
 *		        Text  logText				ʸɽ				
 *		       [Text  messEditor]			Խΰ				
 *		ġġġġġġġġġġġġġġġġġġġġġġġġġġġġġġĨ
 *		ξȤȤˡȯ뤿ΤˤϡΨ
 *		ȯ򻲾Ȥ뤿ˡˡʲξ⥦ɥΥåȤȨ
 *		ˡƤޤ
 *		CurrentMessageInfo *messageInfo;
 *		
 *		
 *		ǤϡʲΥХåؿ롣
 *		  XtAddCallback(logQuit, XtNcallback, finishedAndDestroy, logShell);
 *		  XtAddCallback(logPrev, XtNcallback, prevMessage, messageInfo);
 *		  XtAddCallback(logNext, XtNcallback, nextMessage, messageInfo);
 *		  XtAddCallback(logShell, XtNdestroyCallback, releaseMemory, messageInfo);
 *		
 *		releaseMemory ؿϡΥ뤬˴ݤˡȯΥ
 *		˳뤿ʪǤ
 *		
 ***************************************************************************/
void createLogEditor(Widget parent, char *cnvTextString, 
							Widget *editor, CurrentMessageInfo *messageInfo)
{
	Widget logShell, logPaned;
	Widget logTools, logQuit, logPrev, logNext, logTitle, logText;
	char title[256];
	char *theme = NULL;

	if(strlen(cnvTextString) > 39) {
		theme = cnvTextString + 39;
	}
	sprintf(title, "%5.5s %.*s", cnvTextString, strcspn(theme, "\n\r"), theme);
	/*  */
	logShell = XtVaCreatePopupShell(
				"logShell",
				topLevelShellWidgetClass,
				parent,
				NULL);

	logPaned = XtVaCreateManagedWidget(
				"logPaned",
				panedWidgetClass,
				logShell,
				NULL);

	logTools = XtVaCreateManagedWidget(
				"logTools",
				panedWidgetClass,
				logPaned,
				NULL);

	logQuit = XtVaCreateManagedWidget(
				"logQuit",
				commandWidgetClass,
				logTools,
				NULL);

	logPrev = XtVaCreateManagedWidget(
				"logPrev",
				commandWidgetClass,
				logTools,
				NULL);

	logNext = XtVaCreateManagedWidget(
				"logNext",
				commandWidgetClass,
				logTools,
				NULL);

	logTitle = XtVaCreateManagedWidget(
				"logTitle",
				labelWidgetClass,
				logTools,
				XtNlabel, title, 
				NULL);

	logText = XtVaCreateManagedWidget(
				"logText",
				asciiTextWidgetClass,
				logPaned,
				NULL);

	if(editor != NULL) {
		*editor = XtVaCreateManagedWidget(
					"messEditor", 
					asciiTextWidgetClass,
					logPaned,
					XtNeditType, XawtextEdit,
					NULL);
	}

	XtVaSetValues(logText, XtNstring, cnvTextString, NULL);

/*	
	XtAddCallback(mguiResSet, 
					XtNcallback, SetResource, (XtPointer)mguiResEdit);
	XtAddCallback(mguiResPopdown, XtNcallback, PopdownAncestorShell, NULL);
 */
	XtAddCallback(logShell, XtNdestroyCallback, releaseMemory, messageInfo);
	XtAddCallback(logQuit, XtNcallback, finishedAndDestroy, logShell);
	XtAddCallback(logPrev, XtNcallback, prevMessage, messageInfo);
	XtAddCallback(logNext, XtNcallback, nextMessage, messageInfo);
	XtSetSensitive(logPrev, (messageInfo != NULL && messageInfo->id > 0));
	XtSetSensitive(logNext, (messageInfo != NULL && 
							messageInfo->list != NULL && 
							messageInfo->id < messageInfo->list->num - 1));

	messageInfo->logText   = logText;
	messageInfo->logEditor = ((editor != NULL)?(*editor):(NULL));
	messageInfo->logPrev   = logPrev;
	messageInfo->logNext   = logNext;
	messageInfo->logTitle  = logTitle;
	/* XtAddCallback(logQuit, XtNcallback, XtCallbackPopdown, logShell); */

	XtRealizeWidget(logShell);
	XtPopup(logShell, XtGrabNone);
}

/***************************************************************************
 *	messagePickup: ȯؿ
 *	
 *		LineLink *messagePickup(int number, const struct _treeTitles *info);
 *	
 *		int number;
 *		const struct _treeTitles *info;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
LineLink *messagePickup(int number, const MessTitlesInfo *info)
{
	return(*(info->messages + number));
}

/***************************************************************************
 *	openMessage: åɽԽΥХåؿ
 *	
 *		void openMessage(int index, MessTitlesInfo *messageInfo, Widget *editor_ptr);
 *	
 *		int index;						ꥹȤΥǥå
 *		MessTitlesInfo *messageInfo;	ȥꥹȾ
 *		Widget *editor_ptr;				Խΰ襦åѿΥݥ
 *										NULL ʤ顢Խΰʤ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void openMessage(int index, MessTitlesInfo *messageInfo, Widget *editor_ptr)
{
	LineLink *selected;
	String textString, cnvTextString;
	CurrentMessageInfo *currentInfo;

	currentInfo = (CurrentMessageInfo*)XtMalloc(sizeof(*currentInfo));
	if(currentInfo != NULL) {
		currentInfo->id   = index;
		currentInfo->list = messageInfo;
	}
	selected = messageInfo->messagePickup(index, messageInfo);
	textString = lines4textString(selected);
	cnvTextString = string2otherEncodeNewString(textString, 
						jcodesets[jaSourceEncodeType], jencodes[JaLocale]);
	createLogEditor(topLevel, cnvTextString, editor_ptr, currentInfo);
	XtFree(textString);
}

/***************************************************************************
 *	changeMessage: ؤΥåѹΥХåؿ
 *	
 *		void changeMessage(int index, CurrentMessageInfo *currentInfo);
 *	
 *		int index;							ꥹȤΥǥå
 *		CurrentMessageInfo *currentInfo;	ȥꥹȾ
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void changeMessage(int index, CurrentMessageInfo *currentInfo)
{
	char title[256];
	char *theme = NULL;
	LineLink *selected;
	String textString, cnvTextString;
	MessTitlesInfo *messageInfo = 
						((currentInfo != NULL)?(currentInfo->list):(NULL));

	currentInfo->id = index;
	selected = messageInfo->messagePickup(index, messageInfo);
	textString = lines4textString(selected);
	cnvTextString = string2otherEncodeNewString(textString, 
						jcodesets[jaSourceEncodeType], jencodes[JaLocale]);
	if(strlen(cnvTextString) > 39) {
		theme = cnvTextString + 39;
	}
	sprintf(title, "%5.5s %.*s", cnvTextString, strcspn(theme, "\n\r"), theme);
	XtVaSetValues(currentInfo->logTitle, XtNlabel, title, NULL);
	XtVaSetValues(currentInfo->logText, XtNstring, cnvTextString, NULL);
	XtSetSensitive(currentInfo->logPrev, 
							(currentInfo != NULL && currentInfo->id > 0));
	XtSetSensitive(currentInfo->logNext, (messageInfo != NULL && 
							currentInfo->list != NULL && 
							currentInfo->id < currentInfo->list->num - 1));
	XtFree(textString);
}

/***************************************************************************
 *	selectMessage: åɽԽΥХåؿ
 *	
 *		void selectMessage(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;				å
 *		XtPointer client_data;	ȯ˴ؤ
 *		XtPointer call_data;	
 *	֤
 *		ʤ
 *	
 *		ᥤ󥦥ɥΥɽΥܥ򲡤줿Ȥ˸ƤӽФ
 *		ХåؿǤ
 *		Ǥϡʲν򤷤ޤ
 *		1.ȯΥꥹȤȯƤޤ
 *		2.ȯƤɽǽʥɤѴ롣
 *		3.ȯɥơɽޤ
 *		4.Ū˻Ѥ˴
 *		
 *		
 *		((MessTitlesInfo**)client_data) 
 *		
 *		
 *		CurrentTitles
 *		
 *		*((MessTitlesInfo**)client_data)
 *		
 *		ʢΥݥ󥿤ϡȯ/ĥ꡼ɽڤؤ
 *		ĥ꡼TreeTitles
 *		ȥꥹȾ󨬨
 *		ȯNormalTitlesˡ
 *		ȥꥹȾ󨬨
 *		
 *		message ȯ
 *		LineLink* 
 *		titles
 *		ȥʸ󨡨
 *		 num char*󨭡
 *		
 *		 counter
 *		
 *		 (*strproc)() NULL
 *		
 *		(*messagePickup)()
 *		
 *		
 *		
 *		
 ***************************************************************************/
void selectMessage(Widget w, XtPointer client_data, XtPointer call_data)
{
	XawListReturnStruct *selectNow = NULL;
	MessTitlesInfo *messageInfo = *((MessTitlesInfo**)client_data);

	/*********************************
	 *	ꥹȤθߤμ
	 *********************************/
	selectNow = XawListShowCurrent(logList);
	if(messageInfo != NULL && selectNow->list_index != XAW_LIST_NONE) {
		openMessage(selectNow->list_index, messageInfo, NULL);
	}
}

/***************************************************************************
 *	selectEditor: 
 *	
 *		void selectEditor(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		ʤ
 *	
 *		
 *		((MessTitlesInfo**)client_data) 
 *		
 *		
 *		CurrentTitles
 *		
 *		*((MessTitlesInfo**)client_data)
 *		
 *		ʢΥݥ󥿤ϡȯ/ĥ꡼ɽڤؤ
 *		ĥ꡼TreeTitles
 *		ȥꥹȾ󨬨
 *		ȯNormalTitlesˡ
 *		ȥꥹȾ󨬨
 *		
 *		message ȯ
 *		LineLink* 
 *		titles
 *		ȥʸ󨡨
 *		 num char*󨭡
 *		
 *		 counter
 *		
 *		 (*strproc)() NULL
 *		
 *		(*messagePickup)()
 *		
 *		
 *		
 *		
 *		
 ***************************************************************************/
void selectEditor(Widget w, XtPointer client_data, XtPointer call_data)
{
	XawListReturnStruct *selectNow = NULL;
	MessTitlesInfo *messageInfo = *((MessTitlesInfo**)client_data);
	Widget editor;

	/*********************************
	 *	ꥹȤθߤμ
	 *********************************/
	selectNow = XawListShowCurrent(logList);
	if(messageInfo != NULL && selectNow->list_index != XAW_LIST_NONE) {
		openMessage(selectNow->list_index, messageInfo, &editor);
	}
}

/***************************************************************************
 *	prevMessage: ɽɥȯˤΥåذư
 *	
 *		void prevMessage(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void prevMessage(Widget w, XtPointer client_data, XtPointer call_data)
{
	CurrentMessageInfo *currentMessage = client_data;
	MessTitlesInfo *messageInfo = ((MessTitlesInfo*)
					(currentMessage != NULL)?(currentMessage->list):(NULL));
	Widget editor;
	Widget *editor_ptr = NULL;

	if(currentMessage->logEditor != NULL) {
		editor_ptr = &editor;
	}
	/*********************************
	 *	ꥹȤθߤμ
	 *********************************/
	if(currentMessage->id > 0) {
		if(app_data.moveNewWindow) {
			openMessage(currentMessage->id - 1, messageInfo, editor_ptr);
		} else {
			changeMessage(currentMessage->id - 1, currentMessage);
		}
	}
}

/***************************************************************************
 *	nextMessage: ɽɥȯˤ꼡Υåذư
 *	
 *		void nextMessage(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void nextMessage(Widget w, XtPointer client_data, XtPointer call_data)
{
	CurrentMessageInfo *currentMessage = client_data;
	MessTitlesInfo *messageInfo = ((MessTitlesInfo*)
					(currentMessage != NULL)?(currentMessage->list):(NULL));
	Widget editor;
	Widget *editor_ptr = NULL;

	if(currentMessage->logEditor != NULL) {
		editor_ptr = &editor;
	}
	/*********************************
	 *	ꥹȤθߤμ
	 *********************************/
	if(currentMessage->id < messageInfo->num - 1) {
		if(app_data.moveNewWindow) {
			openMessage(currentMessage->id + 1, messageInfo, editor_ptr);
		} else {
			changeMessage(currentMessage->id + 1, currentMessage);
		}
	}
}

/***************************************************************************
 *	changeMessOrder: ȥꥹȥܥåɽ֤ѹ
 *	
 *		void changeMessOrder(Widget w, 
 *							XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		ʤ
 *	
 *		δؿϡȯȥꥹȤȯ֤ȯ硿ĥ꡼ɽ
 *		Ȥ˻Ѥޤ
 *		Ūˤϡ client_data ȯ硿ĥ꡼Τɤ餫Υ
 *		ꥹȾؤݥ󥿤äƤΤǡ򡢸ߤɽ
 *		ݥѿCurrentTitlesˤޤ
 *		嵭ν򤷤塢ȥꥹȤΥåȤΥꥹȤ򹹿
 *		
 *		
 *		CurrentTitles
 *		
 *		ߤɽ򼨤ݥѿ
 *		
 *		ʢΥݥ󥿤ϡȯ/ĥ꡼ɽڤؤ
 *		ĥ꡼TreeTitles
 *		ȥꥹȾ󨬨
 *		ȯNormalTitlesˡ
 *		ȥꥹȾ󨬨
 *		
 *		
 ***************************************************************************/
void changeMessOrder(Widget w, XtPointer client_data, XtPointer call_data)
{
	char **titles;

	CurrentTitles = 
			((MessTitlesInfo*)((struct menu_data*)client_data)->client_data);
	if(CurrentTitles->titles != NULL) {
		titles = CurrentTitles->titles;
	} else {
		titles = (char **)NullList;
	}
	XawListChange(logList, titles, 0, 0, True);
}

/***************************************************************************
 *	changeMessageMode: ȯ򻲾ȤѤ
 *	
 *		void changeMessageMode(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void changeMessageMode(Widget w, XtPointer client_data, XtPointer call_data)
{
	Boolean flag = *((Boolean*)((struct menu_data*)client_data)->client_data);

	app_data.moveNewWindow = flag;
}

/***************************************************************************
 *	lines2logList: ƤŻҲļȯꥹȤ
 *	
 *		MessTitlesInfo *lines2logList(LineLink *logFile)
 *	
 *		LineLink *logFile;	ơʼʻȹ¤ΤΥ󥯥ȥꥹȡ
 *	֤
 *		򤵤ƤɽˤäȥꥹȾ
 *	
 *		ǤϡʲμǡŻҲļΥե뤫饿ȥꥹ
 *		ޤ
 *		
 *		1. ǡ飱ȯΥ󥯥ȥꥹ
 *		2. ܸ쥨󥳡ɼ̤ȽԤ
 *		3. ȯֹǥȥʸ
 *		4. ĥ꡼¤ɽǤΥȥꥹȤ
 *		5. app_data.treeMode ˱ȯֹ/ĥ꡼¤ξ֤
 *		6. åȤ˥ꥹȤ
 *		
 *		app_data.treeMode False ΤȤȯֹξ֤True 
 *		Ȥĥ꡼¤Υǡ֤ޤʲ˥ǡ¤򼨤ޤ
 *		
 *		
 *		֤ currentTitles ݥ 
 *		
 *		
 *		ȥꥹȾ󨬨ȯ
 *		LineLink* 
 *		message 
 *		ȥʸ󨡨
 *		titles char*󨭡
 *		
 *		 numȯ
 *		
 *		 counterNULL
 *		
 *		 (*strproc)() 
 *		NULL
 *		(*messagePickup)()
 *		
 *		
 *		
 *		
 ***************************************************************************/
MessTitlesInfo *lines2logList(LineLink *logFile)
{
	int encodeType;
	LineLink **messages;
	MessTitlesInfo *currentTitles = NULL;

	messages = messagesCutter(logFile);
	encodeType = checkEncode(logFile, lineLinkStringOut, lineLinkNextString);
	jaSourceEncode(encodeType);		/* ܸΥɤμ̤Ƚꤹ */
	/****************************************************************
	 *	messageNumOrderTitles: ȯֹǥȥʸ
	 *	messageTreeTitles: ĥ꡼¤ɽǤΥȥꥹȤ
	 ****************************************************************/
	NormalTitles = messageNumOrderTitles(messages, newJcodeCnv);
	TreeTitles   = messageTreeTitles(messages, newJcodeCnv);
	if(!app_data.treeMode) {
		currentTitles = &NormalTitles;
	} else {
		currentTitles = &TreeTitles;
	}
	XawListChange(logList, 
			((currentTitles != NULL && currentTitles->titles != NULL)?
				(currentTitles->titles):((char **)NullList)), 0, 0, True);
	return(currentTitles);
}

/***************************************************************************
 *	loadLogFile: ŻҲļɤ߽Ф
 *	
 *		MessTitlesInfo *loadLogFile(const char *filename);
 *	
 *		const char *filename;	ե̾
 *	֤
 *		򤵤ƤɽˤäȥꥹȾ
 *	
 *		ǤϡʲμǡŻҲļΥե뤫饿ȥꥹ
 *		ޤ
 *		
 *		1.ǡ򣱹Υ󥯥ȥꥹȤˤ
 *		2.ܸ쥨󥳡ɼ̤ȽԤ
 *		3. ȯֹǥȥʸ
 *		4. ĥ꡼¤ɽǤΥȥꥹȤ
 *		5. app_data.treeMode ˱ȯֹ/ĥ꡼¤ξ֤
 *		6. åȤ˥ꥹȤ
 *		
 *		app_data.treeMode False ΤȤȯֹξ֤True 
 *		Ȥĥ꡼¤Υǡ֤ޤʲ˥ǡ¤򼨤ޤ
 *		
 *		
 *		֤ currentTitles ݥ 
 *		
 *		
 *		ȥꥹȾ󨬨ȯ
 *		LineLink* 
 *		message 
 *		ȥʸ󨡨
 *		titles char*󨭡
 *		
 *		 numȯ
 *		
 *		 counterNULL
 *		
 *		 (*strproc)() 
 *		NULL
 *		(*messagePickup)()
 *		
 *		
 *		
 *		
 ***************************************************************************/
MessTitlesInfo *loadLogFile(const char *filename)
{
	LineLink *logFile;
	MessTitlesInfo *currentTitles = NULL;

	logFile = readFile(filename);
	currentTitles = lines2logList(logFile);
	return(currentTitles);
}

/***************************************************************************
 *	quit_proc: ץꥱλΤΥХåؿ
 *	
 *		void quit_proc(Widget w, XtPointer client_data, XtPointer call_data);
 *	
 *		Widget w;
 *		XtPointer client_data;
 *		XtPointer call_data;
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void quit_proc(Widget w, XtPointer client_data, XtPointer call_data)
{
	exit(0);
}

/***************************************************************************
 *	getWindowInfo: ɥ˴ؤ
 *	
 *		void getWindowInfo(XWindowAttributes *topAttr, XWindowAttributes *rootAttr);
 *	
 *		XWindowAttributes *topAttr;
 *		XWindowAttributes *rootAttr;
 *	֤
 *		
 *	
 *		
 ***************************************************************************/
void getWindowInfo(XWindowAttributes *topAttr, XWindowAttributes *rootAttr)
{
	Screen *screen = XtScreen(topLevel);

	if(topAttr != NULL && XGetWindowAttributes(XtDisplay(topLevel), 
								XtWindow(topLevel), topAttr)) {
		/* printf("Window Size[%dx%d]\n", topAttr->width, topAttr->height); */
	}
	if(rootAttr != NULL && XGetWindowAttributes(XtDisplay(topLevel), 
								RootWindowOfScreen(screen), rootAttr)) {
		/* printf("Root Window Size[%dx%d]\n", rootAttr->width, rootAttr->height); */
	}
}

/***************************************************************************
 *	TreeMarkSetup: ڹ¤ɽʤޤϡʸˤ˥å
 *	
 *		void TreeMarkSetup(void);
 *	
 *		ʤ
 *	֤
 *		ʤ
 *	
 *		ڹ¤ JIS ʤޤϡʸˤʸ
 *		åȡ
 *	Хѿ
 *		TreeMarks[]
 *		
 ***************************************************************************/
void TreeMarkSetup(void)
{
	int counter;
	char keyword[20];
	const MessageNode *node = NULL;

	MarkDict = makeMessages(NULL, app_data.markString);
	for(counter = 0;counter < 4;++counter) {
		sprintf(keyword, "mk%d", counter);
		node = messageSearch(MarkDict, keyword);
		if(node != NULL && node->message != NULL) {
			TreeMarks[counter] = node->message;
		}
	}
}

/***************************************************************************
 *	usage: ˡɽ
 *	
 *		void usage(const char *program);
 *	
 *		const char *program;	裰ʥץ̾
 *	֤
 *		ʤ
 *	
 *		
 ***************************************************************************/
void usage(const char *program)
{

	fprintf(stderr,"%s:%s\n", keyword2mes("USAGE"), program);
	fprintf(stderr,"       %s [--] [-f %s] [-t / --tree] [-n / --number]\n"
				   "                            [-h / --help] [%s]\n", 
			program, keyword2mes("FILENAME"), keyword2mes("TKOPTION"));
}

/***************************************************************************
 *	main: ᥤؿ
 *	
 *		int main(int argc, char **argv);
 *	
 *		int argc;		θĿ
 *		char **argv;	Υݥ
 *	֤
 *		
 *	
 *		ץΤνפʥåȤκ򤪤ʤ
 *		
 *		
 *		[ĥ꡼¤] 饹̾ 󥹥̾	Ư					
 *		
 *		  Xnmess  xnmess						ץꥱ		
 *		      Paned  mainArea					ᥤ󥦥ɥʬ	
 *		          Box  menuArea				˥塼[*1]		
 *		          Paned  logArea				ͽ[ä˵ǽ̵]	
 *		              Viewport  logView		ǽˤ	
 *		                  List  logList		ȥꥹɽ		
 *		          Box  toolBox				ġ롦ܥåΰ	
 *		              Command  reader			ɽܥ			
 *		              Command  editor			Խդɽܥ
 *		              Command  quit			λܥ				
 *		
 *		
 *		*1: makeMenus() Ǥΰ˥ե˥塼
 *		
 *		
 ***************************************************************************/
int main(int argc, char **argv)
{
	XtAppContext app_context;
	Widget mainArea, menuArea, userMenuButton;
	Widget logArea, logView, toolBox, reader;
	Widget editor, quit;
	LineLink *logFile;
	LineLink **messages;
	char **titles;
	char title[256];
	int encodeType;
	PointorsLink *messageInfo;
	XWindowAttributes topAttr, rootAttr;
	Dimension width, height;
	char program[256];
	const char *messTopRegEx = "^[0-9][0-9][0-9][0-9][0-9]/[0-9][0-9][0-9][0-9][0-9] ";

	XtSetLanguageProc(NULL, NULL, NULL);
	/*localeInfo = localeconv();*/
	sprintf(program, "%.*s", sizeof(program) - 1, *argv);
	
	topLevel = XtVaAppInitialize(
				&app_context,
				"Xnmess",
				options, XtNumber(options), /* command line */
				&argc, argv,
				NULL, 
				NULL);

	XtGetApplicationResources(topLevel, 
				&app_data, 
				resources, 
				XtNumber(resources), 
				NULL, 
				0);

	mainArea = XtVaCreateManagedWidget(
				"mainArea",
				panedWidgetClass,
				topLevel,
				NULL);

	menuArea = XtVaCreateManagedWidget(
				"menuArea",
				boxWidgetClass,
				mainArea,
				NULL);

	makeMenus(menuArea, &fileMenu);
	fileDialogInit(fileMenu.menu);
	XtAddCallback(appMenuInfo[1].myWidget, 
					XtNcallback, fileSelector, &loadSelectorInfomation);

	logArea = XtVaCreateManagedWidget(
				"logArea",
				panedWidgetClass,
				mainArea,
				NULL);

#ifndef	NO_IMPREMENT
	logView = XtVaCreateManagedWidget(
				"logView", 					/* widget name   */
				viewportWidgetClass, 		/* widget class */
				logArea,	 				/* parent widget */
				XtNallowVert, TRUE, 		/*  */
				NULL); 						/* argument list */
#endif
	
	logList = XtVaCreateManagedWidget(
				"logList",
				listWidgetClass,
/*
				logArea,
 */
				logView,
				NULL);

	toolBox = XtVaCreateManagedWidget(
				"toolBox",
				boxWidgetClass,
				mainArea,
				NULL);

	reader = XtVaCreateManagedWidget(
				"reader",
				commandWidgetClass,
				toolBox,
				NULL);

	editor = XtVaCreateManagedWidget(
				"editor",
				commandWidgetClass,
				toolBox,
				NULL);

	quit = XtVaCreateManagedWidget(
				"quit",
				commandWidgetClass,
				toolBox,
				NULL);

	XtAddCallback(quit, XtNcallback, quit_proc, NULL);

	getcwd(Filepath, sizeof(Filepath));

	if(app_data.regexMode) {
		(void)regcomp(&regExPattern, messTopRegEx, REG_EXTENDED | REG_NOSUB);
		isMessageTop = isMessageTop_Regex;
	} else {
		isMessageTop = isMessageTop_Direct;
	}

	LocaleDict = makeMessages(NULL, app_data.messages);
	jaEncodeType();
	localeName = setlocale(LC_CTYPE, NULL);
	TreeMarkSetup();
	if(app_data.help) {
		usage(program);
		exit(0);
	}

	/* messages = getMessages(app_data.file); */
	CurrentTitles = loadLogFile(app_data.file);
	if(app_data.sstdin) {
		CurrentTitles = lines2logList(file2lines(stdin));
	}

	XtAddCallback(reader, XtNcallback, selectMessage, &CurrentTitles);
	XtAddCallback(editor, XtNcallback,  selectEditor, &CurrentTitles);
	if(CurrentTitles->titles == NULL) {
		XtVaSetValues(logView, XtNwidth, 500, NULL);
	}
 
	XtRealizeWidget(topLevel);

	getWindowInfo(&topAttr, &rootAttr);
	XtVaGetValues(logView, XtNwidth, &width, XtNheight, &height, NULL);
	XtVaSetValues(logView, XtNmax, rootAttr.height - 
		(topAttr.height - height + app_data.verticalMargin), NULL);
	/* printf("Hight %d  %d  %d\n", rootAttr.height, topAttr.height, height); */
	/* printf("Hight is %d.\n", rootAttr.height - (topAttr.height - height), NULL); */
	sprintf(title, "Xnmess Version " XNMESS_VERSION " -- [%s]", setlocale(LC_CTYPE, NULL));
	XtVaSetValues(topLevel , XtNtitle, title, NULL);

	XtAppMainLoop(app_context);

	return(0);
}
